<?php
//////////////////////////////////////////////////////////////////////
// MyHeadlines v4.0.0, March 7, 2002
// by:  Mike Agar
//      myh_support@jmagar.com 
//      www.jmagar.com
//////////////////////////////////////////////////////////////////////
// This code is released under GPL refer to the included license.txt
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
// Requirements:
// ~~~~~~~~~~~~~~~~
//	- MySQL v3.23.23 and greater is required. 
//	- MySQL connection must be established before calling "init()" 
//
//

global $myhPath; //this must be set before including this file!!!
global $myh_is_included;
$myh_is_included=1;


/**********************************************************************
Security Fix:  $myhPath must be a local path!  No external resources!!!
*/
$securityCheck = parse_url($myhPath);
if(isset($securityCheck["scheme"])){
    die("Goodbye.");
}


//Data Classes
include_once ("$myhPath/include/gtu.php");
include_once ("$myhPath/include/pd.php");
include_once ("$myhPath/include/templates.php");
include_once ("$myhPath/include/act.php");
include_once ("$myhPath/include/src.php");
include_once ("$myhPath/include/cat.php");
include_once ("$myhPath/include/cache.php");
include_once ("$myhPath/include/stck.php");
include_once ("$myhPath/include/sections.php");

//Utility Classes
include_once ("$myhPath/include/scraper.php");
include_once ("$myhPath/include/rch_client.php");
include_once ("$myhPath/include/mlemos/http.php");
include_once ("$myhPath/include/xmlrpc/xmlrpc.php");
include_once ("$myhPath/include/xmlrpc/xmlrpcs.php");
include_once ("$myhPath/include/SOAPx4/class.soap_client.php");

//MyHeadlines Core Functionality Objects
include_once ("$myhPath/apps/install.php");
include_once ("$myhPath/apps/user.php");
include_once ("$myhPath/apps/rss.php");
include_once ("$myhPath/apps/admin.php");
include_once ("$myhPath/apps/stock_ticker.php");
include_once ("$myhPath/apps/backend.php");


//There can only be ONE http class if these damn timeouts will work... so now it is global used by all...
global $myhHTTP;
$myhHTTP = new agar_http_class();

class MyHeadlines {
	//data classes
	var $gtu;
	var $pd;
	var $template;
	var $act;
	var $cat;
	var $cache;
	var $src;
	var $stck;
	var $backend;
	var $menuHeaders;
	var $menuURL;
	var $frontPage;
	var $prefixURL;
	
	//CMS Abstratcion Layer
	var $prefixURL;

	//State Machine
	var $MYH_DEBUG;
	var $myhLang;
	var $start;
    var $ok2Update=true;
    var $timeout;
    var $userTime=true;

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//CMS Abstraction Layer
	
	function MYH_INIT($url, $table_name_prefix="AGAR", $isAdmin=0, $externalUID=0, $userName=0, $DBG=0){
		
		global $myhPath;
		
		//init internal vars
		$this->MYH_DEBUG = $DBG;
		$this->prefixURL = $url;
		
		//init the PD (configuration class)
		$this->pd = new agar_pd;
		$this->pd->PD_INIT("$table_name_prefix"."_myh_pd",$this->MYH_DEBUG);

		//init the Template System
		$this->template = new myh_template($this->pd,"$table_name_prefix"."_myh_template",$this->MYH_DEBUG);

		//make sure the PD is populated with defaults
		$install = new myh_install;
		$install->Install($this->pd,$this->MYH_DEBUG);
		
		//init all other data classes
		$this->gtu = new agar_gtu;
		$this->gtu->GTU_INIT("$table_name_prefix"."_myh_gtu");
        $this->gtu->useWidgets = true;
        $this->gtu->widgetPath = $myhPath."/images/icon/";
		$this->act = new agar_act;
		$this->act->ACT_INIT("$table_name_prefix"."_myh_act",$this->MYH_DEBUG);
		$this->act->initUser($isAdmin,$externalUID,$userName);

		$this->cache = new agar_cache;
		$this->cache->CACHE_INIT("$table_name_prefix"."_myh_cache",$this->MYH_DEBUG,$this->pd->getValue("rss_cache_expire"));

		$this->cat = new agar_cat;
		$this->cat->CAT_INIT("$table_name_prefix"."_myh_cat",$this->MYH_DEBUG);

		$this->src = new agar_src;
		$this->src->SRC_INIT("$table_name_prefix"."_myh_src",$this->MYH_DEBUG);
        //Do we need to untouch all sources (due to install changes)
        if($this->pd->getValue("untouch_all_srcs")){
            $this->src->untouchAll();
            $this->pd->setValue("untouch_all_srcs",0);
        }

		$this->stck = new agar_stck;
		$this->stck->STCK_INIT("$table_name_prefix"."_myh_stck",$this->MYH_DEBUG);

		$this->backend = new myh_backend($this->prefixURL,"$table_name_prefix"."_myh_backend",$this->MYH_DEBUG);


		$this->myhLang = array();
		$langFile = $this->pd->getValue("default_lang");
		if($langFile==0)$langFile = "not_yet_set";

		if(file_exists($langFile)){
			$fd = fopen ($langFile, "r");
			$contents = fread ($fd, filesize ($langFile));
			fclose ($fd);
			eval($contents);
		}else{
			$this->pd->setValue("default_lang",$myhPath."/lang/english_lang.php");
			$langFile = $this->pd->getValue("default_lang");
			$fd = fopen ($langFile, "r");
			$contents = fread ($fd, filesize ($langFile));
			fclose ($fd);
			eval($contents);
		}
		$this->menuHeaders = array();
		$this->menuURL = array();

		$this->start = time();
		$this->timeout = $this->pd->getValue("max_user_time") + $this->start;

        if($this->pd->getValue("table_prefix")==0){
            $this->pd->setValue("table_prefix",$table_name_prefix."_myh");		
        }

		$this->preProcessor();
	}

	function registerMenuURL($header,$text,$url){
		$this->menuHeaders[$header]=$header;
		$this->menuURL[$header]["text"][] = $text; 	
		$this->menuURL[$header]["url"][] = $url; 	
	}
	
			
		
	
	function showGUI(){//deprecated... use getDashBoard()
		return $this->getDashBoard();
	}
	

	function getDashBoardComponent_Menu(){
		$menu = new myh_menu($this->pd,$this->gtu,$this->myhLang,$this->prefixURL,$this->MYH_DEBUG);
		//Standard MyHeadlines Menu:
		$output = "<b>".$this->myhLang["Menu"]."</b>";
		$output .= $menu->showMenu($this->gtu,$this->act);
		//Sections
		$sects = new agar_section($this->pd->getValue("table_prefix")."_sect",$this->MYH_DEBUG);
        $allSects = $sects->getSectionList();
        $s_end = count($allSects);
        if($s_end>0){
            $output .= "<table><tr><td><nobr><b>".$this->myhLang["Sections"]."</b></nobr></td></tr>";
    		for($s_loop=0;$s_loop<$s_end;$s_loop++){
				$output .= "<tr><td><nobr><a href=".$this->prefixURL."&myh=user&myh_op=showSect";
				$output .= "&myh_sect=".$allSects[$s_loop]->id;
				$output .= ">".$allSects[$s_loop]->name;
				$output .= "</a>";
				if($this->act->isAdmin&&0){//TODO: move this somewhere else <<< COME BACK HERE
				    //show Admin Interface
				    $output .= "</td><td>[";
				    //edit
				    $output .= "<a href=".$this->prefixURL."&myh=admin&myh_op=editSect";
    				$output .= "&myh_sect=".$allSects[$s_loop]->id;
    				$output .= ">".$this->myhLang["Edit"];
    				$output .= "</a>";
				    //delete
				    $output .= "|<a href=".$this->prefixURL."&myh=admin&myh_op=delSect";
    				$output .= "&myh_sect=".$allSects[$s_loop]->id;
    				$output .= ">".$this->myhLang["Delete"];
    				$output .= "</a>";
    				//done
    				$output .= "]</font>\n";
				}
				$output .= "</nobr></td></tr>";                
            }
			$output .= "</table>";
        }
		//Process Registered Menu URLs
		$h_end = count($this->menuHeaders);
		$keys = array_keys($this->menuHeaders);
		for($hLoop=0;$hLoop<$h_end;$hLoop++){
			$output .= "<table><tr><td><nobr><b>".$this->menuHeaders[$keys[$hLoop]]."</b></nobr></td></tr>";
			$u_end = count($this->menuURL[$this->menuHeaders[$keys[$hLoop]]]["text"]);
			for($uLoop=0;$uLoop<$u_end;$uLoop++){
				$output .= "<tr><td><nobr><a href=";
				$output .= $this->menuURL[$this->menuHeaders[$keys[$hLoop]]]["url"][$uLoop];
				$output .= ">".$this->menuURL[$this->menuHeaders[$keys[$hLoop]]]["text"][$uLoop];
				$output .= "</a></nobr></td></tr>";
			}
			$output .= "</table>";
		}	
		return $output;
	}

	function getDashBoardComponent_MainScreen(){
		global $myh,$meid,$eid;
		$output = "";
        if($this->pd->getValue("allow_anonymous")||$this->act->isAdmin||$this->act->isUser){
    		$code = "\$code_dummy_var = 1;";
    		$this->frontPage = false; //Front Page Flag...
    		switch ($myh){
    			case "user":
    				$user = new myh_user($this->pd,$this->cat,$this->src,$this->act,$this->stck,$this->myhLang,$this->prefixURL,$this->MYH_DEBUG);
    				$code = $user->getScreenCode();
    				break;
    			case "admin":
    				$admin = new myh_admin($this->pd,$this->cat,$this->src,$this->act,$this->stck,$this->myhLang,$this->prefixURL,$this->MYH_DEBUG);
    				$user = &$admin;
    				$code = $admin->getScreenCode();
    				break;
    			case "menu":
    				$menu = new myh_menu($this->pd,$this->gtu,$this->myhLang,$this->prefixURL,$this->MYH_DEBUG);
    				$user = new myh_user($this->pd,$this->cat,$this->src,$this->act,$this->stck,$this->myhLang,$this->prefixURL,$this->MYH_DEBUG);
    				$code = $menu->getScreenCode();
    				break;
    			default:
    				//This must be the front page...
    				$this->frontPage = true;
    				break;
    		}
    
    		if($this->frontPage){
    			$output .= $this->pd->getValue("front_page");
    		}else{
    			eval($code);
          		$output = "<h2>".myhMenuTreeCallBack($meid,$tid)."</h2>".$output;
      			$output .= "<hr>\n";
    			$output .= $this->myhResetButton($this->myhLang["Done"]);
    		}
        }else{
            $output .= "<blockquote><h2>".$this->myhLang["Access_Denied"]."</h2></blockquote>";
			$this->frontPage = true; //this will show the stock ticker block...
        }
		return $output;
	}

	function getDashBoardComponent_StockTicker($javascript=1){
        global $myhHTTP;
        $myhHTTP->user_agent = $this->pd->getValue("rss_User-Agent_string");
		$stocks = new myh_stock($this->pd);
		$subs = $this->getSubs("st");
		//$box = $stocks->myhStockBox($this->pd,$this->stck,$this->myhLang,$subs,$this->prefixURL,$javascript);
		//Java script is not working in v4.2.3...
		$box = $stocks->myhStockBox($this->pd,$this->stck,$this->myhLang,$subs,$this->prefixURL,0); 
		$output .= $box["content"];
		return $output;
	}
		
	function getDashBoardComponent_UserSubscriptions(){
	    $subs = array();
	    $subs["lt"] = $this->showBlocksVert("lt");
	    $subs["ct"] = $this->showBlocksVert("ct");
	    $subs["rt"] = $this->showBlocksVert("rt");
	    $subs["lb"] = $this->showBlocksVert("lb");
	    $subs["cb"] = $this->showBlocksVert("cb");
	    $subs["rb"] = $this->showBlocksVert("rb");

	    $subs["ltd"] = $this->showBlocksVert("lt",1);
	    $subs["ctd"] = $this->showBlocksVert("ct",1);
	    $subs["rtd"] = $this->showBlocksVert("rt",1);
	    $subs["lbd"] = $this->showBlocksVert("lb",1);
	    $subs["cbd"] = $this->showBlocksVert("cb",1);
	    $subs["rbd"] = $this->showBlocksVert("rb",1);
		$output = $this->template->userSubscriptionScreen($subs);
		return $output;
	}
	
	function userSubscriptionScreen(){
	    return $this->getDashBoardComponent_UserSubscriptions();  
	}

	function getDashBoard(){
		$dbc = array();
		$dbc["user_subs"] = $this->getDashBoardComponent_UserSubscriptions();
		$dbc["menu"] = $this->getDashBoardComponent_Menu();
		$dbc["stock_ticker"] = $this->getDashBoardComponent_StockTicker(0);
		$dbc["stock_ticker_js"] = $this->getDashBoardComponent_StockTicker(1);
		$dbc["main_screen"] = $this->getDashBoardComponent_MainScreen();
		return $this->template->getDashBoard($dbc,$this->act->isAdmin);
	}

	function getSubs($place){
		/************************************************
		place can be one of:
			lt = Top Left
			lb = Bottom Left
			rt = Top Right
			rb = Bottom Right
			ct = Top Center
			cb = Bottom Center
			st = Stock Subscriptions
		**************************************************/
		if($this->MYH_DEBUG)echo "getSubs($place): start<br>\n";
		$user = new myh_user($this->pd,$this->cat,$this->src,$this->act,$this->stck,$this->myhLang,$this->prefixURL,$this->MYH_DEBUG);
		$subs = $user->userTree->getSubscriptions($this->gtu,$this->act,$user->userTree->myh_user_place[$place]);
		$mand = $user->userTree->getSubscriptions($this->gtu,$this->act,$user->userTree->myh_user_place[$place],1);
		$subs = array_merge($subs,$mand);
		if($this->MYH_DEBUG){
			$count = count($subs);
			echo "getSubs($place): (count = $count) end<br>\n";
		}
		return $subs; 
	}


	function getCache($sd, $show_desc=0, $show_all=0, $count_items=0){
		global $myhPath;
        $promo = $this->pd->getValue("promote_enabled");
		$rtn=array();
		//get src specific info
		$rtn["title"]=$this->src->getTitle($sd);
		$rtn["image"] = $this->src->getImage($sd);
		$rtn["url"] = $this->src->getURL($sd,1,$this->prefixURL);
		$rtn["next_update"] = $this->src->getNextUpdate($sd);
		$rtn["content"] = "";
		//get the items
		if($count_items==0){
		    $numToShow = $this->pd->getValue("rss_max_items");
		}else{
		    $numToShow = $count_items;
		}
		$items = $this->cache->getItems($sd);
		if($show_all)$numToShow = count($items);
		$showDesc  = ($this->pd->getValue("rss_show_summary")||$show_desc);
		$rtn["content"]  = $this->template->getContent($items,$numToShow,$showDesc,$this->backend, $promo);
		$more  = "<a href=";
		$more .= $this->prefixURL;
		$more .= "&myh=user&myh_op=show_all&eid=";
		$more .= $sd;	
		$more .= ">".$this->myhLang["more_like_this"]."</a>";
		$rtn["more_link"] = $more;
		$subLink  = "<a href=";
		$subLink .= $this->prefixURL;
		$subLink .= "&myh=user&myh_op=sub1&eid=";
		$subLink .= $sd;	
		$subLink .= ">".$this->myhLang["Subscribe"]."</a>";
		$rtn["subscribe_link"] = $subLink;
        if($promo){
            $rtn["promote"] = "<input type=image src=$myhPath/images/bullhorn.gif align=middle>";
        }else{
            $rtn["promote"] = "";    
        }
		
	 	return $rtn;
	}

	function getStats($horizontal=0){//if you want it horzontal (main menu) set this to 1
	    return "<p>MyHeadlines->getStats() : deprecated in version 4.2.5<p>";
        	
	}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//State Macine Functions
	
	function updateCache($sd){
        global $myhHTTP,$myhPath;

        $shameless = $this->pd->getValue("show_shameless_plug");

        $myhHTTP->user_agent = $this->pd->getValue("rss_User-Agent_string");
		if($this->userTime){
	        $socket_time_limit = $this->pd->getValue("max_user_time");
        }else{
	        $socket_time_limit = $this->pd->getValue("rss_timeout");
        }
		$catTree = new myh_cat_tree($this->MYH_DEBUG);
		if(!($catTree->isGoodSrc($this->pd,$this->gtu,$sd))){
			$this->src->touch($sd);
			return; //Head Nurse Looked up and said, "Leave that one alone..."
			        //  - (sorry, listening to George Thorogood right now)
		}
		if($this->src->isStale($sd)){
			//reset timeout clock on this src first.  You get one try at it!  
			//if this hangs it will not hold up other cron cycles (until it expires again...)
			$this->src->touch($sd); 

			$rss = new myh_rss($this->pd,$this->MYH_DEBUG);
    		$myhHTTP->debug=$this->MYH_DEBUG;

			//go get this src's file...
			$url = $this->src->getURL($sd);
			$file = "";
			$again = true;
			while(($again)&&($myhHTTP->time_left()>0)){
				$again = false; //break after this run...

			    $file = $myhHTTP->get_page($url,$socket_time_limit);			

			    //Handle HTTP Error Codes:
                //See:  http://diveintomark.org/tests/client/http/
			    $resultCode = $myhHTTP->get_http_result_code();
			    if($resultCode<300){
            	    //Assume 200 nothing to do...
                }else if($resultCode < 400){
            	    //300's
                    $url = $myhHTTP->reply_headers["location"];
                    switch($resultCode){
                	    case 301:
                    	    //Update the src URL
                            $this->src->setURL($sd,$url);
					    default:
                    	    //Check the location URL...
							$again = true;

                    }
                }else if($resultCode < 500){
            	    //400's
                    switch($resultCode){
                	    case 410:
                	    case 403:
                            //forbidden or permanent....
                            $catTree->badSrc($this->pd,$this->gtu,$this->src,$sd,1); //instant Bad!!!
                            break;
					    default:
                    }
                    $file = 0;
                }else if($resultCode < 600){
            	    //500's
                    $file = 0;
                }

			}


		    $rss->lastURL = $url; //needed to help out a bit...

			if(!$file){
				if($rss->MYH_DEBUG)echo "Connection has Failed<br>\n";
				//   thoughts: - change the timeout for the src to a large number 2 days?
				//   TODO:     - clear this src's cache, and insert an appropriate error message

                if($shameless){
                    $image = "$myhPath/images/myh.gif";
                }else{
                    $image = "$myhPath/images/1x1.gif";
                }

				$this->src->setImage($sd,$image);
				$catTree->badSrc($this->pd,$this->gtu,$this->src,$sd);
			}else{
				if($rss->MYH_DEBUG)echo "updateCache(): Connection and retrieval completed<br>\n";
				if($this->src->isScraped($sd)){
				    //new scraper engine...
				    $template = $this->src->getTemplate($sd);
		    		$channel = $rss->rssScrapePage($file,$template,$shameless);
				}else{
    				$channel = $rss->rssParsePage($file,$shameless);
				}
				if($rss->MYH_DEBUG) echo "updateCache(): ".$channel["title"]."<br>\n";

				//TODO: scrub $image to eliminate known bad images from default backend.php files
				$this->src->setImage($sd,$channel["image"]);
		
				//Add Items
				$items = $channel["items"];
				$end = count($items);
				if($end){
				    //found some items must be a good src
					$catTree->goodSrc($this->pd,$this->gtu,$this->src,$sd);
				}else{
				    //no items returned... mark as bad
					$catTree->badSrc($this->pd,$this->gtu,$this->src,$sd);
				}
				$newStuff=0;
				$oldStuff=0;
                for($loop=0;$loop<$end;$loop++){
				    //determine if this feed is "All" new? or if there is old stuff and new stuff
				    $item = serialize($items[$loop]);
                    if ($this->cache->isItem($item,$sd)&&0){
					    $oldStuff=1;
					    $loop=$end; //end this process, hitting old items, and we don't want to recycle expired stuff...
					}else{
					    $newStuff=1;
					}
			    }
                if($newStuff){
    				for($loop=$end;$loop>0;$loop--){
    				//tarverse the rss items in reverse order to ensure the temporal integrity
    					if($rss->MYH_DEBUG){
    						$it = $items[$loop-1];
    						echo "UC:  ( $loop / $end ) $it->title <br>\n";
    					}
    					$item = serialize($items[$loop-1]);
    					if ($this->cache->isItem($item,$sd)&&0){
    					    $oldStuff=0; //found the old stuff, now we can start adding new stuff...
    					    $loop=0; //end this process, hitting old items, and we don't want to recycle expired stuff...
    					}else{
    					    if(!$oldStuff){
        					    $cid = $this->cache->saveItem($item,$sd);
    					    }
    					}
    				}
                }
			}
		
			//delete expired items...
			$this->cache->flushCache($sd,$this->pd->getValue("rss_max_items"));	
		
		}
	}

	function refreshExpired(){
		$stale = $this->src->listStale();
		$end = count($stale);
		$breakout = 0;
		$output = "";
        $this->userTime=false;
		@set_time_limit($this->pd->getValue("rss_timeout"));
		$breakoutlimit=$this->pd->getValue("max_updates_per_cron_cycle");
		for($loop=0;$loop<$end;$loop++){
			$this->updateCache($stale[$loop]);
			$breakout++;
			$temp = $this->src->getTitle($stale[$loop]);
			$output .= "refreshExpired(): $breakout/$breakoutlimit/$end - $temp <br>\n";
			if($breakout>=$breakoutlimit)$loop=$end; //exit condition
		}
		$output .= "<p><a href=".$this->prefixURL." target=_blank>".$this->myhLang["Done"]."</a>\n";

		return $output;
	}	
	
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Internal Utilities.
	function preProcessor(){
		global $myh;
		$restore_menu = 0;
		switch ($myh){
		    case "backend":
		        //XML_RCP, Scraper, RSS1.0, Export, things like that
        		$catTree = new myh_cat_tree($this->MYH_DEBUG);
        		$catTree->INIT_CALLBACK($this->cat,$this->src);
        		$catTree->INIT_URL_PREFIX($this->prefixURL);
                $restore_menu = $this->backend->preProcessing($this->pd,$this->gtu,$this->cat,$this->src,$this->cache,$catTree,$this);
		        break;
			case "user":
				$user = new myh_user($this->pd,$this->cat,$this->src,$this->act,$this->stck,$this->myhLang,$this->prefixURL,$this->MYH_DEBUG);
				$restore_menu = $user->preProcessing($this->pd,$this->gtu,$this->src,$this->stck,$this->act,$this->cache);
				break;
			case "admin":
				$admin = new myh_admin($this->pd,$this->cat,$this->src,$this->act,$this->stck,$this->myhLang,$this->prefixURL,$this->MYH_DEBUG);
				$restore_menu = $admin->preProcessing($this->pd,$this->gtu,$this->src,$this->stck,$this->act,$this->cat,$this->cache,$this->template);
				break;
			default:
		}
		if($restore_menu)$this->restoreMenu();
	}

	function restoreMenu(){
		global $myh,$meid,$eid;
		$myh = "menu";
	}


	function myhFormStart($myhState){
		global $meid,$eid,$pid,$tid,$gid,$context;
		$myh_form_start = "";
		if($this->MYH_DEBUG&&0){
			$myh_form_start .= "<form action=\"".$this->prefixURL."\" method=\"get\">\n";
		}else{
			$myh_form_start .= "<form action=\"".$this->prefixURL."\" method=\"post\">\n";
		}
		$myh_form_start .= "
							<input type=\"hidden\" name=\"context\" value=\"$context\">\n 
							<input type=\"hidden\" name=\"gid\" value=\"$gid\">\n 
							<input type=\"hidden\" name=\"eid\" value=\"$eid\">\n 
							<input type=\"hidden\" name=\"tid\" value=\"$tid\">\n 
							<input type=\"hidden\" name=\"pid\" value=\"$pid\">\n
							<input type=\"hidden\" name=\"myh\" value=\"$myhState\">\n
							";
		if(isset($meid)){
			$myh_form_start .= "<input type=\"hidden\" name=\"meid\" value=\"$meid\">\n ";
		}
		
	
		return $myh_form_start;
	}
	
	function myhFormEnd($submit){
		$output = 	"
					<input type=\"submit\" value=\"$submit\">\n
					</form>\n
					";
		return $output;
	}


	function myhResetButton($button){
		eval($this->pd->getValue("reset_button"));
		$myh_form_start = str_replace("{tag_line}",$this->pd->getValue("tag_line"),$myh_form_start);
		return $myh_form_start;
	}

	function configForm($what, $template=0){
        if($template){
            $value = $this->template->getValue($what);
        }else{
    		$value = $this->pd->getValue($what);
        }
		$output = "";
		$output .= "<p><table><tr><td valign=top width=100%>\n";
		$output .= $this->myhFormStart("admin");
		$output .= "$what";
		$output .= "</td><td valign=top>\n";
		$output .= "<input type=\"hidden\" name=\"myh_conf\" value=\"$what\">\n";
		if($template){
            $output .= "<input type=\"text\" width=80 name=\"myh_value\" value=\"$value\">\n";
    		$output .= "<input type=\"hidden\" name=\"myh_op\" value=\"saveTemplate\">\n";
		}else{
    		$output .= "<input type=\"text\" width=80 name=\"myh_value\" value=\"$value\">\n";
    		$output .= "<input type=\"hidden\" name=\"myh_op\" value=\"saveConfig\">\n";
		}
		$output .= "</td><td valign=top>\n";
		$output .= $this->myhFormEnd($this->myhLang["Save"]);
		$output .="</td></table><hr>\n";
		return $output;
	}

	function configFormTextArea($what, $template=0){
        if($template){
            $value = $this->template->getValue($what);
        }else{
    		$value = $this->pd->getValue($what);
        }
		$output = "";
		$output .= "<p><table><tr><td valign=top width=100%>\n";
		$output .= $this->myhFormStart("admin");
		$output .= "$what";
		$output .= "</td><td valign=top>\n";
		$output .= "<input type=\"hidden\" name=\"myh_conf\" value=\"$what\">\n";
        if($template){
    		$output .= "<textarea name=\"myh_value\" cols=\"80\" rows=\"15\" wrap=\"off\">".stripslashes($value)."</textarea>\n";
    		$output .= "<input type=\"hidden\" name=\"myh_op\" value=\"saveTemplate\">\n";
        }else{
    		$output .= "<textarea name=\"myh_value\" cols=\"80\" rows=\"5\" wrap=\"off\">".stripslashes($value)."</textarea>\n";
    		$output .= "<input type=\"hidden\" name=\"myh_op\" value=\"saveConfig\">\n";
        }
		$output .= "</td><td valign=top>\n";
		$output .= $this->myhFormEnd($this->myhLang["Save"]);
		$output .="</td></table><hr>\n";
		return $output;
	}


	function dispBlock($box){
	    global $context, $meid;

        $box["promote_action"] = $this->prefixURL;
        $box["promote_action"] .= "&context=$context&myh=user&myh_op=promote";
    	if(isset($meid)){
    		$box["promote_action"] .= "&meid=$meid";
    	}

        $box["image_width"] = $this->pd->getValue("rss_logo_width");
        $box["image_override"] = $this->pd->getValue("rss_override_logo_width");

		$output = $this->template->dispBlock($box);
		return $output;
	}
	
	function showBlocksVert($pos,$show_desc=0,$show_all=0){
		$output = "<table border=0 width=100%>\n<!-- $pos -->\n";
		$subs = $this->getSubs($pos);
		$end = count($subs);
        $this->userTime=true;
		for($loop=0;$loop<$end;$loop++){
			$sd = $subs[$loop];
			$output .= "<tr>\n<td>\n";
			if($this->ok2Update){
    			$this->updateCache($sd);
                if($this->timeout<time()){
                    $this->ok2Update = false;
                }
			}
			$box = $this->getCache($sd,$show_desc,$show_all);
			$output .= $this->dispBlock($box);
			$output .= "</td>\n</tr>\n";
		}
		$output .= "</table>\n";
		return $output;	
	}

	function doGoogleSearch($search,$start){
		$soapDebug = false;
		$max=(int)10;
		if($this->MYH_DEBUG||$soapDebug)echo "<p>Begin SOAP:";
		$query = array();
		$query["key"] = $this->pd->getValue("google_registration_key");
		if($soapDebug||$this->MYH_DBEUG)echo "Google Registration Key: ".$query["key"]."<br>";
		$query["q"] = $search;
		$query["start"] = (int)$start;
		$query["maxResults"] = $max;
		$query["filter"] = (boolean)true;
		$query["restrict"]="";
		$query["safeSearch"]=(boolean)false;
		$query["lr"]="";
		$query["ie"]="latin1";
		$query["oe"]="latin1";
		$soapclient = new soapclient("http://api.google.com/search/beta2");
		if($this->MYH_DEBUG||$soapDebug)$soapclient->debug_flag = true;
		$google_results = $soapclient->call("doGoogleSearch",$query,"urn:GoogleSearch","doGoogleSearch");
		if($this->MYH_DEBUG||$soapDebug)echo nl2br($soapclient->debug_data);
		if($soapDebug||$this->MYH_DBEUG){
			echo "<hr>Result: <br>";
			$this->renderArray($google_results,"google_results");
			echo "<hr>";
		}
		if($this->MYH_DEBUG||$soapDebug)echo "<p>End SOAP:<p>";
		////////////////Begin Drawing the Google Results/////////////////////
		if(is_array($google_results)){
			$outArray = array();
			$outArray["html"]="<table width=100% border=0>";
			$outArray["more"]=0;
			$end = count($google_results["resultElements"]);
			if($end==$max){
				$outArray["more"]=1;
			}
			
			for($loop=0;$loop<$end;$loop++){
				$hit = $google_results["resultElements"][$loop];
				$idx = $loop + $start;
				$outArray["html"].="<tr><td align=right valign=top>".$idx."&nbsp;-&nbsp;</td><td valign=top colspan=2><a target=new href=";
				$outArray["html"].=$hit["URL"];
				$outArray["html"].=">".$hit["title"]."</a></td></tr><tr><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>";
				$outArray["html"].="<td></td><td width=100% valign=top>".$hit["snippet"]."<br>&nbsp;</td></tr>";
			}
			$outArray["html"].="</table>";
		}else{
			$outArray = false;	
		}
		/////////////////////////////////////////////////////////////////////
		return $outArray;
	}

	function renderArray($arr,$name){
	//Handy little tool for displaying multi dimensional arrays
	//I found this really helped understand the results returned by Google's SOAP API
		if(is_array($arr)){
			$keys = array_keys($arr);
			$end = count($keys);
			for($loop=0;$loop<$end;$loop++){
				if(is_array($arr[$keys[$loop]])){
					MyHeadlines::renderArray($arr[$keys[$loop]],$name."[".$keys[$loop]."]");
				}else if(is_object($arr[$keys[$loop]])){
					$out .=  $name."[".$keys[$loop]."]"." = ".serialize($arr[$keys[$loop]])."<br>";
				}
			}
		}else{
			$out .= "$name is not an array, it is $arr <br>";
		}
		return $out;
	}

    function uniqueArray($arr){
        //will return all of the unique values from the array
        $out = array();
        $in = array_values($arr);
        $end = count($in);
        for($loop=0;$loop<$end;$loop++){
            $out[$in[$loop]] = $in[$loop];
        }
        return array_values($out);
    }

	function uninstall(){
		//make sure the PD is populated with defaults
		$install = new myh_install;
		$install->UnInstall();		
	}
}
?>