<?php
//////////////////////////////////////////////////////////////////////
// MyHeadlines v4.0.0, March 15, 2002
// by:  Mike Agar
//      www.jmagar.com
//////////////////////////////////////////////////////////////////////
// This code is released under GPL refer to the included license.txt
//////////////////////////////////////////////////////////////////////

/********************************
Channel definition
~~~~~~~~~~~~~~~~~~
channel["title"]				=source title/name
channel["link"]					=link to the source site
channel["description"]	=descript of this channel's content/purpose
channel["image"]				=site logo/image/banner
channel["items"]				=an ARRAY of RSS_ITEM's (see below) NOTE 
*/

class RSS_ITEM {
	var $title;				//headline
	var $link;				//link to story
	var $description;	//synopsis of story
}

class myh_rss {
	///////////////////////////////////////////////////////////////////
	// Connection and Download Functions
	var $MYH_DEBUG;
	var $lastURL;
	var $picWidth;
	
	function myh_rss($myh_pd,$dbg=0){
		global $myhPath;
		$this->MYH_DEBUG = $dbg;	
		if(!$myh_pd->getValue("rss_initialized")){
			//init rss
			if($this->MYH_DEBUG)echo "RSS: Initializing RSS Defaults<br>\n";
			$myh_pd->setValue("rss_initialized",1);
			$myh_pd->setValue("rss_timeout",5);
			$myh_pd->setValue("rss_proxy_enabled",0);
			$myh_pd->setValue("rss_max_items",6);
			$myh_pd->setValue("rss_show_summary",0);
			$myh_pd->setValue("rss_logo_width",120);
			$myh_pd->setValue("rss_override_logo_width",1);
			$myh_pd->setValue("rss_cache_expire","30");//days
			$myh_pd->setValue("rss_pow_img","<a href=http://www.jmagar.com><img alt=MyHeadlines src=$myhPath/images/myh.gif border=0></a>");
		}
        $this->picWidth = $myh_pd->getValue("rss_logo_width");
	}
	
	
	function glue_url($parsed) { 
        //Thanks "Anonymous" from the PHP Web site documentation comments....
        if (! is_array($parsed)) return false;
        if (isset($parsed['scheme'])) {
            $sep = (strtolower($parsed['scheme']) == 'mailto' ? ':' : '://');
            $uri = $parsed['scheme'] . $sep;
        } else {
            $uri = '';
        }
        
        if (isset($parsed['pass'])) {
            $uri .= "$parsed[user]:$parsed[pass]@";
        } elseif (isset($parsed['user'])) {
            $uri .= "$parsed[user]@";
        }
        
        
        if (isset($parsed['host'])) $uri .= $parsed['host'];
        if (isset($parsed['port'])) $uri .= ":$parsed[port]";
        if (isset($parsed['path'])){
            $pos = strpos($parsed['path'],'/');
            if($pos === false){
                //not found
                    $uri .= '/';
            }else{
                //found...
                if($pos!=0){
                    $uri .= '/';
                }
            }
            $uri .= $parsed['path'];
        }
        if (isset($parsed['query'])) $uri .= "?$parsed[query]";
        if (isset($parsed['fragment'])) $uri .= "#$parsed[fragment]"; 
        if($this->MYH_DEBUG){
            echo "glue_url:  ".$uri."<br>\n";
        }
        
        return $uri; 
    }

	function antiAntiScraper($input){
		//counters the antiscraping techniques of some sites...
		$output = $input;
		$output = eregi_replace("imgsrc", "img src", $output);  //Yahoo! Images
		$output = eregi_replace("\"\+\"", "", $output);			//Security News Portal...
		return $output;
	}
	
	function fixURL($input){
	    $baseURL = parse_url($this->lastURL);
	    $inURL = parse_url($input);
        if($this->MYH_DEBUG){
            MyHeadlines::renderArray($baseURL,"baseURL");
            MyHeadlines::renderArray($inURL,"inURL");
        }
	    if(isset($inURL['scheme'])){
	        return $input;
	    }else{
	        if($inURL['path'][0]=="/"){
	            $baseURL['path'] = $inURL['path'];
	        }else{
    	        $baseURL['path'] = "/".dirname($baseURL['path']). "/";
    	        $baseURL['path'] .= $inURL['path'];
                $baseURL['path'] = str_replace("//","/",$baseURL['path']);
//            $baseURL['path'] = ereg_replace("/\./","/",$baseURL['path']);
	        }
	        if (isset($inURL['query'])) $baseURL['query'] = $inURL['query'];
	        if (isset($inURL['fragment'])) $baseURL['fragment'] = $inURL['fragment'];
            return $this->glue_url($baseURL);        
	    }
	}
	
	function rssScrapePage($rss_file,$template,$shameless=1){
        global $myhPath;
   		$scp = new agar_scraper($this->MYH_DEBUG);
   		$scraps = array();
   		$scraps = $scp->templateScrape($rss_file,$template);
        if($this->MYH_DEBUG){
            MyHeadlines::renderArray($scraps,"Scraps");
        }
		if(isset($scraps["site_name"])){
    		$channel["title"] = myh_backend::scrub(($scraps["site_name"]));
		}else{
    		$channel["title"] = "MyHeadlines Scraped Feed";
		}
		$channel["link"] = $this->lastURL;
		if(isset($scraps["slogan"])){
    		$channel["description"] = myh_backend::scrub($scraps["slogan"]);
		}else{
    		$channel["description"] = myh_backend::scrub("<a href=http://www.jmagar.com>MyHeadlines</a> by Mike Agar");
		}
		if(isset($scraps["image"])){
    		$channel["image"] = $this->fixURL($scraps["image"]);
		}else{
            //No image so decide what to do here...
            if($shameless){
                $channel["image"] = "$myhPath/images/myh.gif";
            }else{
                $channel["image"] = "$myhPath/images/1x1.gif";
            }
        }
        $items = array();
        for($loop=0;$loop<20;$loop++){
            $varTitle = "title_".$loop;
            $varDesc = "desc_".$loop;
            $varLink = "link_".$loop;
            //two new scraper vars:
            $varPic = "pic_".$loop; //this is the URL for the image of the story
            $varEnc = "enclosure_".$loop; //this is the URL for the enclosure of the story
            $varFrag = "frag_".$loop;//if not a URL for the link but instead a fragment, ignore {link_0} use {frag_0}
                                //I will leave this undocumented, since I can't think of a case to test it...
            if(isset($scraps[$varTitle])){
       		    $item = new RSS_ITEM;
                $item->title = myh_backend::scrub($scraps[$varTitle]);
                $item->link = $this->antiAntiScraper($this->fixURL($scraps[$varLink]));
                $item->description = "";
                if(strlen($scraps[$varPic])>3){
                    $item->description .= "<img src=\"";
                    $item->description .= $this->antiAntiScraper($this->fixURL($scraps[$varPic]));
                    $item->description .= "\"><br>";
                    
                }
                
                $item->description .= $this->antiAntiScraper(myh_backend::scrub($scraps[$varDesc]));    

                if(strlen($scraps[$varEnc])>3){
                    $item->description .= "<nobr><a href=\"";
                    $item->description .= $this->antiAntiScraper($this->fixURL($scraps[$varEnc]));
                    $item->description .= "\" target=\"blank\"> [...]</a></nobr>";
                }
                
                $items[] = $item;
            }
        }
		$channel["items"]=$items;
		return $channel;
        
	}
	function rssParsePage($rss_file, $shameless=1){
	##################################################################################
	# Modified to meet MyHeadlines needs... 
	# I took this from Post Nuke & Pim van der Zwet (pim@zwet.com)
	# Ripped the example from: http://zend.com/codex.php?id=644&single=1
	# Original author: goliche@goliche.org <goliche@goliche.org>
	# Uses regular expressions to parse the XML file (no support for old style yet)
	##################################################################################
	//TODO: use a ezxml class to parse this and other formats... (www.zez.org)	
        global $myhPath;
        
		$rss_array = array();
		$content = array();

        $rss_file = eregi_replace("<items","<rdf_items",$rss_file);		
        $rss_file = eregi_replace("</items","</rdf_items",$rss_file);
        //massage for atom
        $rss_file = eregi_replace("<entry","<item",$rss_file);		
        $rss_file = eregi_replace("</entry","</item",$rss_file);
        $rss_file = eregi_replace("</summary","</description",$rss_file);
        $rss_file = eregi_replace("<summary","<description",$rss_file);
        		
    	$searchfile = eregi("<channel(.*)</channel>", $rss_file ,$arrayreg); 
        if(!count($arrayreg)){
            //no <channel> tag  (may be an atom feed)
            $arrayreg[0] = $rss_file;
        }else{
        
		    eregi("<title>(.*)</title>",$arrayreg[0], $title); 
		    eregi("<link>(.*)</link>",$arrayreg[0], $link); 
		    eregi("<description>(.*)</description>",$arrayreg[0], $description); 
		    $channel["title"] = eregi_replace("</title>.*","",$title[1]);
		    $channel["link"] = eregi_replace("</link>.*","",$link[1]);
		    $channel["description"] = eregi_replace("</description>.*","",$description[1]);
        }
		$searchfile = eregi("<image(.*)</image>", $rss_file ,$arrayreg); 
		eregi("<url>(.*)</url>",$arrayreg[0], $url);
		$channel["image"] = $url[1];
        if(strlen($channel["image"])<4){
            //No image so decide what to do here...
            if($shameless){
                $channel["image"] = "$myhPath/images/myh.gif";
            }else{
                $channel["image"] = "$myhPath/images/1x1.gif";
            }
        }

        $searchfile = eregi("<item(.*)</item>", $rss_file ,$arrayreg); 
		$filechunks = explode("<item", $arrayreg[0]); 
		$count = count($filechunks); 

		for($i=1 ; $i<$count ;$i++) 
		{ 
			$title = $description = $links = 0;
			eregi("<title>(.*)</title>",$filechunks[$i], $title); 
			eregi("<link>(.*)</link>",$filechunks[$i], $links); 
			eregi("<description>(.*)</description>",$filechunks[$i], $description);
			$item = new RSS_ITEM;
			$item->title = myh_backend::scrub(eregi_replace("</title>.*","",$title[1]));
			$item->description = myh_backend::scrub(eregi_replace("</description>.*","",$description[1]));
			$item->link = $this->fixURL(eregi_replace("</link>.*","",$links[1]));
			if(strlen($item->title)<1){
				$item->title = $item->link;
			}
			$rss_array[] = $item;
		} 
		$channel["items"]=$rss_array;
		return $channel;
	}
	

	function previewChannel($url,$template=false){
        global $myhHTTP;

        $myhHTTP->debug=$this->MYH_DEBUG;

	    $file = $myhHTTP->get_page($url,15); //timeout	of 15 seconds is reasonable		

        //header
		$output = $myhHTTP->render_header();

		if($myhHTTP->get_http_result_code() < 300){ //2XX is good
            if($template){
        	    $channel = $this->rssScrapePage($file,$template);
            }else{
        	    $channel = $this->rssParsePage($file);        
            }

		    $output .=  "<hr>$channel[title]<br>\n";
		    if(strlen($channel["link"])>4)$output .=  "<a href=".$channel["link"]." target=_blank>".$channel["link"]."</a><br>\n";
		    $output .= $channel["description"]."<br>\n";
		    if(strlen($channel["image"])>4)$output .= "<img src=".$channel["image"]."><br>\n";
		    $output .= "<br><ul>\n";
		    $items = $channel["items"];
		    $end = count($items);
		    for($loop=0;$loop<$end;$loop++){
			    $item = $items[$loop];
			    $output .= "<a href=$item->link target=_blank>$item->title</a><br>\n";
			    if(strlen($item->description)>4)$output .= "<ul>$item->description</ul><br>\n";	
		    }
		    $output .= "</ul>\n";	
        }
		return $output;
	}
}
?>
