<?php
/*
 * http.php
 *
 * @(#) $Header: /cvsroot/myheadlines/myh4/myh4/MyHeadlines/include/mlemos/http.php,v 1.3 2003/11/08 04:44:47 jmagar_com Exp $
 *
 */

/********************************************************************************
Modified for MyHeadlines, by Mike Agar

Refer to for the purpose of this effort...
http://diveintomark.org/archives/2003/07/21/atom_aggregator_behavior_http_level.html


*/

class agar_http_class
{
	var $host_name="";
	var $host_port=80;
	var $proxy_host_name="";
	var $proxy_host_port=80;

	var $request_method="GET";
	var $user_agent="MyHeadlines";
	var $request_uri="/";
	var $protocol_version="1.1";
	var $debug=0;
    var $log_to_disk=false;
	var $support_cookies=0;
	var $cookies=array();
	var $reply_headers; //An Array of the response header lines...MyHeadlines is gonna try to respond accordingly

	/* private variables - DO NOT ACCESS */

	var $start;
    var $timeout;
    
    var $state="Disconnected";
	var $connection=0;
	var $content_length=0;
	var $read_length=0;
	var $request_host="";
	var $next_token="";
	var $months=array(
		"Jan"=>"01",
		"Feb"=>"02",
		"Mar"=>"03",
		"Apr"=>"04",
		"May"=>"05",
		"Jun"=>"06",
		"Jul"=>"07",
		"Aug"=>"08",
		"Sep"=>"09",
		"Oct"=>"10",
		"Nov"=>"11",
		"Dec"=>"12");

	/* Private methods - DO NOT CALL */

	Function agar_http_class(){
    	$this->start = time();
        $this->timeout = 7; //Human Threshold for waiting...
        if($this->log_to_disk)$this->debug_log("################ agar_http_class: CONSTRUCTOR ##################");    

        register_shutdown_function(array(&$this, "ShutDown"));
    }

    Function ShutDown(){
        $this->Close();  //clean up any open sockets if the script is killed off...
        if($this->log_to_disk)$this->debug_log("################ agar_http_class: DESTRUCTOR  ##################");    
    }

	Function Tokenize($string,$separator="")
	{
		if(!strcmp($separator,""))
		{
			$separator=$string;
			$string=$this->next_token;
		}
		for($character=0;$character<strlen($separator);$character++)
		{
			if(GetType($position=strpos($string,$separator[$character]))=="integer")
				$found=(IsSet($found) ? min($found,$position) : $position);
		}
		if(IsSet($found))
		{
			$this->next_token=substr($string,$found+1);
			return(substr($string,0,$found));
		}
		else
		{
			$this->next_token="";
			return($string);
		}
	}

	Function OutputDebug($message)
	{
		if($this->debug)echo "HTTP: ".$message."<br>\n";
	}

	Function GetLine()
	{
        $line=0;
		if($this->time_left()>0){
			if(!feof($this->connection)){
			    $line=fgets($this->connection,1024);
			    $length=strlen($line);
			    if(($length>=2) && (substr($line,$length-2,2)=="\r\n")){
				    $line=substr($line,0,$length-2);
				    if($this->debug)$this->OutputDebug("< $line");
                    if($this->log_to_disk)$this->debug_log("GetLine() < $line");    
			    }
            }
		}else{
            if($this->debug)$this->OutputDebug("GetLine(): TIMED OUT");
            if($this->log_to_disk)$this->debug_log("GetLine(): TIMED OUT");    
        }
	    return($line);
	}

	Function PutLine($line)
	{
		if($this->debug)
			$this->OutputDebug("> $line");
        if($this->log_to_disk)$this->debug_log("PutLine() > $line");    
		return(fputs($this->connection,"$line\r\n"));
	}

	Function PutData($data)
	{
		if($this->debug)
			$this->OutputDebug("> $data");
		return(fputs($this->connection,$data));
	}

	Function ReadBytes($length)
	{
    	$bytes = "";
        if($this->time_left()>0){
//            if($this->log_to_disk)$this->debug_log("ReadBytes() >>> Call fread()");
			$bytes=fread($this->connection,$length);
//           if($this->log_to_disk)$this->debug_log("ReadBytes() <<< Back fread()");
            if($this->debug)
			        $this->OutputDebug("< $bytes");
		}else{
        	if($this->debug)
				$this->OutputDebug("ReadBytes(): TIMED OUT");
            if($this->log_to_disk)$this->debug_log("ReadBytes(): TIMED OUT");                    
        }   
        return($bytes);
	}

	Function EndOfInput()
	{
		switch($this->state){
        	case "Disconnected":
			case "Closed":
			case "TimedOut":
			    return true;
            default:
        		return(feof($this->connection));
        }
	}

	Function Connect($host_name,$host_port,$timeout)
	{
		$this->timeout = $timeout;
        $timeLeft = $this->time_left();
        if($timeLeft>=1){
            if($this->debug)$this->OutputDebug("Connecting to $host_name (timeout=".$timeout.")");
		    $this->connection=fsockopen($host_name,$host_port,$error,$errStr,$timeLeft);
            if($this->connection==0)
		    {
			    switch($error)
			    {
				    case -3:
					    return("-3 socket could not be created");
				    case -4:
					    return("-4 dns lookup on hostname \"".$host_name."\" failed");
				    case -5:
					    return("-5 connection refused or timed out");
				    case -6:
					    return("-6 fdopen() call failed");
				    case -7:
					    return("-7 setvbuf() call failed");
				    default:
					    return($error." could not connect to the host \"".$host_name."\"");
			    }
		    }
		    else
		    {
                $timeLeft = $this->time_left();
                if($timeLeft>=1){
			        $this->state="Connected";
                    if($this->debug)
				        $this->OutputDebug("Connected to $host_name");
                    if($this->log_to_disk)$this->debug_log("Connect(): Connected to $host_name");    
			        socket_set_timeout($this->connection, $this->time_left());
                    return("");
                }else{
                    $this->Close("TimedOut");
                }
		    }
        }else{
            $this->Close("TimedOut");
        }
	}

	Function Disconnect()
	{
		if($this->debug)$this->OutputDebug("Disconnected from ".$this->host_name);
        if($this->log_to_disk)$this->debug_log("Disconnect(): Disconnected from ".$this->host_name);
		if($this->connection)fclose($this->connection);
		return("");
	}

	/* Public methods */

	Function Open($arguments, $timeout=7) //Human threshold for waiting is 7 seconds...
	{
		switch($this->state){
        	case "Disconnected":
        	case "Closed":
                break;
        	case "TimedOut":
        		return("2 already Timed Out");
            default:
        		return("1 already connected");
        }
		if(IsSet($arguments["HostName"]))
			$this->host_name=$arguments["HostName"];
		if(IsSet($arguments["HostPort"]))
			$this->host_port=$arguments["HostPort"];
		if(IsSet($arguments["ProxyHostName"]))
			$this->proxy_host_name=$arguments["ProxyHostName"];
		if(IsSet($arguments["ProxyHostPort"]))
			$this->proxy_host_port=$arguments["ProxyHostPort"];
		if(strlen($this->proxy_host_name)==0)
		{
			if(strlen($this->host_name)==0)
				return("2 it was not specified a valid hostname");
			$host_name=$this->host_name;
			$host_port=$this->host_port;
		}
		else
		{
			$host_name=$this->proxy_host_name;
			$host_port=$this->proxy_host_port;
		}
		$error=$this->Connect($host_name,$host_port,$timeout);
		if(strlen($error)!=0){
            if($this->debug)
				$this->OutputDebug("Open(): Error =  $error");
            if($this->log_to_disk)$this->debug_log("Open(): Error =  $error");
            $this->Close();
        }            
		return($error);
	}

	Function Close($futureState="Closed")
	{
		switch($this->state){
        	case "Disconnected":
				return("1 already disconnected");
        	case "Closed":
				return("2 already closed");
        	case "TimedOut":
				return("3 already closed: TimedOut!");
            default:
            	break;
        }
		$error=$this->Disconnect();
		$this->state=$futureState;
		return($error);
	}

	Function SendRequest($arguments)
	{
		switch($this->state)
		{
			case "Disconnected":
				return("1 connection was not yet established");
			case "Connected":
				break;
			default:
				return("2 can not send request in the current connection state");
		}
		if(IsSet($arguments["RequestMethod"]))
			$this->request_method=$arguments["RequestMethod"];
		if(IsSet($arguments["User-Agent"]))
			$this->user_agent=$arguments["User-Agent"];
		if(strlen($this->request_method)==0){
            $this->Close();
			return("3 it was not specified a valid request method");
        }
		if(IsSet($arguments["RequestURI"]))
			$this->request_uri=$arguments["RequestURI"];
		if(strlen($this->request_uri)==0 || substr($this->request_uri,0,1)!="/"){
            $this->Close();
			return("4 it was not specified a valid request URI");
        }
		$request_body="";
		$headers=(IsSet($arguments["Headers"]) ? $arguments["Headers"] : array());
		if($this->request_method=="POST")
		{
			if(IsSet($arguments["PostValues"]))
			{
				$values=$arguments["PostValues"];
				if(!is_array($values)){
                    $this->Close();
					return("5 it was not specified a valid POST method values array");
                }
				for($request_body="",Reset($values),$value=0;$value<count($values);Next($values),$value++)
				{
					if($value>0)
						$request_body.="&";
					$request_body.=Key($values)."=".UrlEncode($values[Key($values)]);
				}
				$headers["Content-type"]="application/x-www-form-urlencoded";
			}
			else
			{
				if(IsSet($arguments["Body"]))
					$request_body=$arguments["Body"];
			}
		}
		if(strlen($this->proxy_host_name)==0)
			$request_uri=$this->request_uri;
		else
			$request_uri="http://".$this->host_name.($this->host_port==80 ? "" : ":".$this->host_port).$this->request_uri;

        //Start to send the Data...
        if($this->time_left()>=1){
		    $success=$this->PutLine($this->request_method." ".$request_uri." HTTP/".$this->protocol_version);
            if($success){
			    $body_length=strlen($request_body);
                if($body_length>0){
                    $headers["Content-length"]=$body_length;
                }
                $host_set=0;
                Reset($headers);
                $hCount = count($headers);
			    for($header=0;$header<$hCount;$header++)
			    {
				    if($success){
                        $header_name=Key($headers);
				        $header_value=$headers[$header_name];
				        if(is_array($header_value))
				        {
					        Reset($header_value);
                            $vCount = count($header_value);
                            for($value=0;$value<$vCount;$value++)
					        {
                                if($success){
                                    $success=$this->PutLine("$header_name: ".$header_value[Key($header_value)]);
                                    Next($header_value);
                                }else{
                                    $value=$vCount; //loop end condition
                                }
					        }
				        }
				        else
				        {
					        $success=$this->PutLine("$header_name: $header_value");
				        }
				        if(strtolower(Key($headers))=="host")
				        {
					        $this->request_host=strtolower($header_value);
					        $host_set=1;
				        }
                        Next($headers);
                    }else{
                        $header=$hCount; //loop end condition
                    }
			    }
			    if($success)
			    {
				    if(!$host_set)
				    {
					    $success=$this->PutLine("Host: ".$this->host_name);
					    $this->request_host=strtolower($this->host_name);
				    }
				    if($success)
				    {
					    $success=$this->PutLine("User-Agent: ".$this->user_agent);
                        $success=$this->PutLine("");
					    if($body_length && $success)
						    $success=$this->PutData($request_body);
				    }
			    }
		    }
        }else{
            $this->Close("TimedOut");
            return("6 could not send the HTTP request : Timed Out");
        }
		if(!$success){
			$this->Close();
            return("5 could not send the HTTP request");
        }
		$this->state="RequestSent";
		return("");
	}

	Function ReadReplyHeaders(&$headers)
	{
		switch($this->state)
		{
			case "Disconnected":
				return("1 connection was not yet established");
			case "Connected":
				return("2 request was not sent");
			case "RequestSent":
				break;
			default:
				return("3 can not get request headers in the current connection state (".$this->state.")");
		}
		$this->reply_headers=array();
		$this->content_length=$this->read_length=0;
		$this->content_length_set=0;
        $timeLeft = $this->time_left();
		while($timeLeft > 0)
		{
			$line=$this->GetLine();
			if(GetType($line)!="string")
				return("4 could not read request reply");
			if($line=="")
			{//Only valid exit path and state change... all others are failures!
				$this->state="GotReplyHeaders";
				return("");
			}
			$header_name=strtolower($this->Tokenize($line,":"));
			$header_value=Trim(Chop($this->Tokenize("\r\n")));
			if(IsSet($this->reply_headers[$header_name]))
			{
				if(GetType($this->reply_headers[$header_name])=="string")
					$this->reply_headers[$header_name]=array($this->reply_headers[$header_name]);
				$this->reply_headers[$header_name][]=$header_value;
			}
			else
				$this->reply_headers[$header_name]=$header_value;
			switch($header_name)
			{
				case "content-length":
					$this->content_length=intval($this->reply_headers[$header_name]);
					$this->content_length_set=1;
					break;
				case "set-cookie":
                    break;
			}
            $timeLeft = $this->time_left();
        }
        $this->Close("TimedOut");
		return("TIMED OUT");
	}

	Function ReadReplyBody(&$body,$length)
	{
		switch($this->state)
		{
			case "Disconnected":
				return("1 connection was not yet established");
			case "Connected":
				return("2 request was not sent");
			case "RequestSent":
                $error=$this->ReadReplyHeaders($headers);//move to the next state...
				if($error!="")return($error);
				break;
			case "GotReplyHeaders":
				break;
			default:
				return("3 can not get request headers in the current connection state (state = ".$this->state.") ");
		}
		$body="";
		if($this->content_length_set)
			$length=min($this->content_length-$this->read_length,$length);
        if($length>0 && !$this->EndOfInput()){
            $body = $this->ReadBytes($length);
            if(strlen($body)==0)return("4 could not get the request reply body");
        }else{
            $this->Close();
        }
        if($this->time_left()>0){
		    $this->read_length+=$length;
		    return("");
        }else{
            $this->Close("TimedOut");
        	return("TIMED OUT");
        }
	}

	Function GetPersistentCookies(&$cookies)
	{
		$cookies=array();
        return;
	}

//////////////
// AGAR Addons

	function time_left(){
	    $rtn = 0;
		//returns number of seconds until timeout expires
		$left = $this->timeout - (time()-$this->start);
        if($left > 0){
        	$rtn = $left;
        }
	    return $rtn;
    }

	function debug_log($msg){
    	$fp = fopen("http_log.txt","a");
        fwrite($fp,$this->start." $msg (time left = ".$this->time_left().")\n");
        fflush($fp);
        fclose($fp);
    }

	function get_http_result_code(){
    	switch($this->state){
			case "Disconnected":
				return("1 connection was not yet established<br>");
			case "Connected":
				return("2 request was not sent<br>");
			case "RequestSent":
				if(($error=$this->ReadReplyHeaders($headers))!="")
					return($error);
				break;
            case "TimedOut":
            	return 490;
                break;
			case "Closed":
			case "GotReplyHeaders":
				break;
			default:
				return("3 can not get request headers in the current connection state<br>");
		}
		$keys = array_keys($this->reply_headers);
		
		if(is_array($keys)){
	        return substr($keys[0],9,3);    
        }else{
        	return 499;
        }
    }

	function render_header(){
    	switch($this->state){
			case "Disconnected":
				return("1 connection was not yet established<br>");
			case "Connected":
				return("2 request was not sent<br>");
			case "RequestSent":
				if(($error=$this->ReadReplyHeaders($headers))!="")
					return($error);
				break;
            case "Closed":
			case "GotReplyHeaders":
				break;
			default:
				return("3 can not get request headers in the current connection state (".$this->state.")<br>");
		}

    	$arr = $this->reply_headers;
		if(is_array($arr)){
			$keys = array_keys($arr);
			$end = count($keys);
			for($loop=0;$loop<$end;$loop++){
				$out .=  $keys[$loop].": ".$arr[$keys[$loop]]."<br>";
			}
		}else{
			$out .= "4 reply_headers is not an array, it is $arr <br>";
		}
		return $out;
	}


	function get_page($url, $timeout){
        $this->timeout = $timeout;
        if($this->log_to_disk)$this->debug_log(">>> get_page() START");    
        if($this->log_to_disk)$this->debug_log("URL = $url");    
    	$page = "";
    	$parts = parse_url($url);

	    $this->host_name=$parts["host"];
	    $this->host_port=($parts["port"])?$parts["port"]:80;

	    $this->request_uri = ($parts["path"])?$parts["path"]:"/";
	    if($parts["query"]) $this->request_uri .= '?'.$parts["query"];	

        $Header = array(); //custom headers to be added to the HTTP request
        $Header["Connection"]="close";
	    if($parts["proxy_user"]){
            $Header["Proxy-Authorization"]="Basic ".base64_encode($parts["proxy_user"].":".$parts["proxy_pass"]); 
	    }

	    if($parts["user"]){
		    //authentication is on		
		    if($this->debug)OutputDebug("Adding User Account Info");
		    $Header["Authorization"] = "Basic ".base64_encode("$parts[user]:$parts[pass]");
	    }

	    $args = array();
        $args["Headers"] = $Header; 
		$start = time();

        $err = $this->Open($args,$timeout);
        if($err){
            if($this->debug)$this->OutputDebug("Error Connecting to $url = $err");
	        if($this->log_to_disk)$this->debug_log("Error Connecting to $url = $err");    
        }else{
            $err = $this->SendRequest($args);
            if($err){
                if($this->debug)$this->OutputDebug("Error Sending Request to $url = $err");
		        if($this->log_to_disk)$this->debug_log("Error Sending Request to $url = $err");    
            }else{
            	$err = "";
                $length = 1024;
                $wCount = 0;
                $maxLoopCount = 200;  //(200*1024 = 200KB is a big file for a RSS Feed...)
   	            if($this->log_to_disk)$this->debug_log("get_page(): Starting to download page in $length byte blocks");    
	            while((!$this->EndOfInput())
                		&&(strlen($err)==0)
                        &&($this->time_left()>0)
                        && ($wCount++ < $maxLoopCount)
                        ){
                	$body = "";
                    $err = $this->ReadReplyBody($body,$length);
                    if($err){
                        $page .= "<p>Error Reading Reply from $url = $err<p>";
       	                if($this->debug)$this->OutputDebug($page);
				        if($this->log_to_disk)$this->debug_log("Error Reading Reply from $url = $err");    
                    }else{
	                    $page .= $body;
                    }
                }
                if($this->log_to_disk)$this->debug_log("get_page(): Finished downloading page");    

            }
            $this->Close();
		}
        if($this->log_to_disk)$this->debug_log("<<< get_page() END");    
        return $page;
	}

};

?>