<?php

class rch_client {
    var $dbgXMLRPC = false;
    var $errText;
    
    function rch_client(){
	//These error definitions taken from Linux "asm/errno.h" - My best guess as to the source
	//of the messages when this part of the code fails.  Only 3 have been reported out in the wild
	//but almost any of these are possible...  So now we give better descriptions of the RCH failure.

    	$this->errText = array();
	$this->errText["0"] = " Unable to connect to host ";
	$this->errText["1"] = " Operation not permitted ";
	$this->errText["2"] = " No such file or directory ";
	$this->errText["3"] = " No such process ";
	$this->errText["4"] = " Interrupted system call ";
	$this->errText["5"] = " I/O error ";
	$this->errText["6"] = " No such device or address ";
	$this->errText["7"] = " Arg list too long ";
	$this->errText["8"] = " Exec format error ";
	$this->errText["9"] = " Bad file number (socket not yet created?)"; //MyHeadlines: Seen in the wild
	$this->errText["10"] = " No child processes ";
	$this->errText["11"] = " Try again ";
	$this->errText["12"] = " Out of memory ";
	$this->errText["13"] = " Permission denied (Do you have permission to use fsockopen()? Check with your ISP.)"; //MyHeadlines: Seen in the wild
	$this->errText["14"] = " Bad address ";
	$this->errText["15"] = " Block device required ";
	$this->errText["16"] = " Device or resource busy ";
	$this->errText["17"] = " File exists ";
	$this->errText["18"] = " Cross-device link ";
	$this->errText["19"] = " No such device ";
	$this->errText["20"] = " Not a directory ";
	$this->errText["21"] = " Is a directory ";
	$this->errText["22"] = " Invalid argument ";
	$this->errText["23"] = " File table overflow ";
	$this->errText["24"] = " Too many open files ";
	$this->errText["25"] = " Not a typewriter ";
	$this->errText["26"] = " Text file busy ";
	$this->errText["27"] = " File too large ";
	$this->errText["28"] = " No space left on device ";
	$this->errText["29"] = " Illegal seek ";
	$this->errText["30"] = " Read-only file system ";
	$this->errText["31"] = " Too many links ";
	$this->errText["32"] = " Broken pipe ";
	$this->errText["33"] = " Math argument out of domain of func ";
	$this->errText["34"] = " Math result not representable ";
	$this->errText["35"] = " Resource deadlock would occur ";
	$this->errText["36"] = " File name too long ";
	$this->errText["37"] = " No record locks available ";
	$this->errText["38"] = " Function not implemented ";
	$this->errText["39"] = " Directory not empty ";
	$this->errText["40"] = " Too many symbolic links encountered ";
	$this->errText["42"] = " No message of desired type ";
	$this->errText["43"] = " Identifier removed ";
	$this->errText["44"] = " Channel number out of range ";
	$this->errText["45"] = " Level 2 not synchronized ";
	$this->errText["46"] = " Level 3 halted ";
	$this->errText["47"] = " Level 3 reset ";
	$this->errText["48"] = " Link number out of range ";
	$this->errText["49"] = " Protocol driver not attached ";
	$this->errText["50"] = " No CSI structure available ";
	$this->errText["51"] = " Level 2 halted ";
	$this->errText["52"] = " Invalid exchange ";
	$this->errText["53"] = " Invalid request descriptor ";
	$this->errText["54"] = " Exchange full ";
	$this->errText["55"] = " No anode ";
	$this->errText["56"] = " Invalid request code ";
	$this->errText["57"] = " Invalid slot ";
	$this->errText["59"] = " Bad font file format ";
	$this->errText["60"] = " Device not a stream ";
	$this->errText["61"] = " No data available ";
	$this->errText["62"] = " Timer expired ";
	$this->errText["63"] = " Out of streams resources ";
	$this->errText["64"] = " Machine is not on the network ";
	$this->errText["65"] = " Package not installed ";
	$this->errText["66"] = " Object is remote ";
	$this->errText["67"] = " Link has been severed ";
	$this->errText["68"] = " Advertise error ";
	$this->errText["69"] = " Srmount error ";
	$this->errText["70"] = " Communication error on send ";
	$this->errText["71"] = " Protocol error ";
	$this->errText["72"] = " Multihop attempted ";
	$this->errText["73"] = " RFS specific error ";
	$this->errText["74"] = " Not a data message ";
	$this->errText["75"] = " Value too large for defined data type ";
	$this->errText["76"] = " Name not unique on network ";
	$this->errText["77"] = " File descriptor in bad state ";
	$this->errText["78"] = " Remote address changed ";
	$this->errText["79"] = " Can not access a needed shared library ";
	$this->errText["80"] = " Accessing a corrupted shared library ";
	$this->errText["81"] = " .lib section in a.out corrupted ";
	$this->errText["82"] = " Attempting to link in too many shared libraries ";
	$this->errText["83"] = " Cannot exec a shared library directly ";
	$this->errText["84"] = " Illegal byte sequence ";
	$this->errText["85"] = " Interrupted system call should be restarted ";
	$this->errText["86"] = " Streams pipe error ";
	$this->errText["87"] = " Too many users ";
	$this->errText["88"] = " Socket operation on non-socket ";
	$this->errText["89"] = " Destination address required ";
	$this->errText["90"] = " Message too long ";
	$this->errText["91"] = " Protocol wrong type for socket ";
	$this->errText["92"] = " Protocol not available ";
	$this->errText["93"] = " Protocol not supported ";
	$this->errText["94"] = " Socket type not supported ";
	$this->errText["95"] = " Operation not supported on transport endpoint ";
	$this->errText["96"] = " Protocol family not supported ";
	$this->errText["97"] = " Address family not supported by protocol ";
	$this->errText["98"] = " Address already in use ";
	$this->errText["99"] = " Cannot assign requested address ";
	$this->errText["100"] = " Network is down ";
	$this->errText["101"] = " Network is unreachable ";
	$this->errText["102"] = " Network dropped connection because of reset ";
	$this->errText["103"] = " Software caused connection abort ";
	$this->errText["104"] = " Connection reset by peer ";
	$this->errText["105"] = " No buffer space available ";
	$this->errText["106"] = " Transport endpoint is already connected ";
	$this->errText["107"] = " Transport endpoint is not connected ";
	$this->errText["108"] = " Cannot send after transport endpoint shutdown ";
	$this->errText["109"] = " Too many references: cannot splice ";
	$this->errText["110"] = " Connection timed out "; //MyHeadlines: Seen in the wild
	$this->errText["111"] = " Connection refused ";
	$this->errText["112"] = " Host is down ";
	$this->errText["113"] = " No route to host ";
	$this->errText["114"] = " Operation already in progress ";
	$this->errText["115"] = " Operation now in progress ";
	$this->errText["116"] = " Stale NFS file handle ";
	$this->errText["117"] = " Structure needs cleaning ";
	$this->errText["118"] = " Not a XENIX named type file ";
	$this->errText["119"] = " No XENIX semaphores available ";
	$this->errText["120"] = " Is a named type file ";
	$this->errText["121"] = " Remote I/O error ";
	$this->errText["122"] = " Quota exceeded ";
	$this->errText["123"] = " No medium found ";
	$this->errText["124"] = " Wrong medium type ";
    }
    
    function isValidResponse($r,$c){
        $err = false;
	    $eNum = 0;
//Again: this is ripped off from HPE v1.0, Mike Krus, www.newsisfree.com
//HPE Code Start
    	if($r == 0)
    	{
    		$eNum = $c->errno;
		    $output .= "<p>Error: ($eNum : 1) ".$this->errText["$eNum"]."<p>";
    		$err |= true;
    	}
    	else
    	{
    		$v = $r->value();
    
    		if (!$r->faultCode())
    		{
    			if(!$v->scalarval()){
				$err |= true;
				$output .= "<p>Not a Scalar Value!<p>";
			}
    
    		}
    		else
    		{
    			$eNum = $r->faultCode();
			    $output .= "<p>Error: ($eNum  : 2) ".$this->errText["$eNum"]."<p>";
    			$err |= true;
    		}
    	}
//HPE Code End

        if($err)die("<p>MyHeadlines encountered an error while connecting to the RCH Server<p> $output");
        return true;
    }

    function getObject($name,$ik,$ak){
        //XML_RCP Client
        $set_to_off = false;
        $rtn = "";
        $client = new agar_xmlrpc_client("/modules.php?op=modload&name=RCH&file=xmlrpc","www.jmagar.com");
        $client->setDebug($this->dbgXMLRPC);
        $message = new agar_xmlrpcmsg("getObject");
        $message->addParam(new agar_xmlrpcval($name));//object name
        $message->addParam(new agar_xmlrpcval($ik)); //IK
        $message->addParam(new agar_xmlrpcval($ak)); //AK
        $resp = $client->send($message);
        if($this->isValidResponse($resp,$client)){
            if($this->dbgXMLRPC)MyHeadlines::renderArray(get_object_vars($resp),"XML_RESP");
            //if($this->dbgXMLRPC)MyHeadlines::renderArray(get_object_vars($resp->value()),"XML_RESP->value");
            $value = ($resp->value());
            $rtn = $value->scalarval();
        }
        return $rtn;
    }

    function getInstanceKey(){
        //XML_RCP Client
        $client = new agar_xmlrpc_client("/modules.php?op=modload&name=RCH&file=xmlrpc","www.jmagar.com");
        $client->setDebug($this->dbgXMLRPC);
        //Get Instance Key
        $message = new agar_xmlrpcmsg("getInstanceKey");
        $resp = $client->send($message);
        if($this->isValidResponse($resp, $client)){
            if($this->dbgXMLRPC)MyHeadlines::renderArray(get_object_vars($resp),"XML_RESP");
            //if($this->dbgXMLRPC)MyHeadlines::renderArray(get_object_vars($resp->value()),"XML_RESP->value");
            $value = ($resp->value());
            return $value->scalarval();
        }else{
            return 0;
        }
    }
   
}

?>
