<?php
//////////////////////////////////////////////////////////////////////
// Scraper v3.0.0, October 29, 2002
// by:  Mike Agar
//      www.jmagar.com
//////////////////////////////////////////////////////////////////////
// This code is released under GPL refer to the included license.txt
//////////////////////////////////////////////////////////////////////

class agar_scraper {
	var $debug;
	var $NoError; //if error detected global to break out...
    var $pagePtr; //now a part of the object no need to pass it around...

	function agar_scraper($dbg=0){
		$this->debug = $dbg;
	}

    function charSearch($needle, $haystack){
        $this->pagePtr = $haystack;
        if($this->debug)echo "CS(): Needle = $needle <br>";
        if($this->debug)echo "CS(): Haystack = $haystack ";
        if(strpos($haystack,$needle)!== FALSE){
            //found
            $output  = substr($haystack,strlen($needle)+strpos($haystack,$needle));
			if($this->debug)echo "- found<br>\n";
			$this->pagePtr = $output;
			return $output;
        }else{
            //not found
			$this->NoError = 0;
			if($this->debug)echo "- not found<br>\n";
			$this->pagePtr = "";
			return "";
        }
    }
	
	function finish($haystack, $needle){
        $this->pagePtr = $haystack;
        if($this->debug)echo "finish(): Needle = $needle <br>";
        if($this->debug)echo "finish(): Haystack = $haystack ";
        if(strpos($haystack,$needle)!== FALSE){
            //found
    		$needleLength = strlen($needle);
            $output  = substr($haystack,0,strpos($haystack,$needle));
            $this->pagePtr = substr($haystack,strlen($needle)+strpos($haystack,$needle));
			if($this->debug)echo "- found<br>\n";
			return $output;
        }else{
            //not found
			$this->NoError = 0;
			if($this->debug)echo "- not found<br>\n";
			$this->pagePtr = "";
			return "";
        }	   
	}
	
	function stripLineEnds($in){
	    $in = ereg_replace("\n","",$in);
	    $in = ereg_replace("\r","",$in);
	    $in = ereg_replace("\t","",$in);
        return $in;
	}
	
	function scrape($preArray, $start, $end, $page){
		$this->NoError = 1; //all is fine
		$lend = count($preArray);
		$pagePtr = $this->stripLineEnds($page);
		for($arLoop=0;$arLoop<$lend;$arLoop++){
			$pagePtr = $this->charSearch($this->stripLineEnds($preArray[$arLoop]),$pagePtr);
			if(!$this->NoError)$arLoop=$lend; //break out if not found
		}
		//finished searching for the preArray elements... verify success
		if($this->NoError){
		  //look for start delimiter
			if($this->NoError)$pagePtr = $this->charSearch($this->stripLineEnds($start),$pagePtr);
			if($this->NoError){
				//Start delimiter has been found...  scrape the text.
				$pagePtr = $this->finish($pagePtr,$this->stripLineEnds($end));
			}
		}
		if($this->NoError){
			return $pagePtr;
		}else{
			return "";
		}
	}
	
	
	function templateScrape($page,$template){
        /*************************************************************************
        Template Syntax:
            All scraped content will be passed back in an array whose keys are 
            defined by the template place holder names.  A template place holder
            is characterized by a {} pair, the name of the place holder is
            inserted between the {} pair:  {scraped_value}
            
            A normal implementation would be to save the source from the page
            to be scraped and insert the place holders by overwriting the 
            content within the page. For advanced techniques contact me at
                scraper@jmagar.com
        */
        
        if($this->debug)echo "templateScrape() - start<br>\n";
        $this->pagePtr = $this->stripLineEnds($page);
        $template = $this->stripLineEnds($template);
		$this->NoError = 1; //all is fine
        $patterns = explode("{",$template);
        $output = array();
        $end = count($patterns);
        $start = 0;
        //detect current state
        if(strstr($patterns[0],"}")){
            //first pattern is a variable
            if($this->debug)echo "templateScrape() - first pattern is a variable<br>\n";
            $state = "capture";
        }else{
            //first pattern is an index
            if(strlen($patterns[0])>0){
                if($this->debug)echo "templateScrape() - first pattern is an Index (".$patterns[0].")<br>\n";
                $state = "index";
                $index = $patterns[0];
            }else{
                if($this->debug)echo "templateScrape() - first pattern is a Variable<br>\n";
                $state = "capture";
                $start = 1;
            }
        }
        if($this->debug)echo "templateScrape() - start = $start , end = $end <br>\n";
        for ($loop=$start;$loop<$end;$dummy++){
            if($this->debug)echo "templateScrape() - state = $state<br>\n";
            switch($state){
                case "index":
                    $this->pagePtr = $this->charSearch($index,$this->pagePtr);
                    $loop++;
                    $state = "capture";
            		break;
                case "capture":
              		$pieces = explode("}",$patterns[$loop],2);
            		$cnt = @count($pieces);
                    if($this->debug)echo "templateScrape() - cnt = $cnt<br>\n";
            		if($cnt == 2){
            		    //have var name and next pattern...
            		    if(strlen($pieces[1])>=1){
                		    $output[$pieces[0]] = $this->finish($this->pagePtr,$pieces[1]);
            		    }else{
            		        //last one...
            		        $output[$pieces[0]] = $this->pagePtr;
                			$this->NoError = 0;        		        
            		    }
            		    $index = $output[$pieces[0]];
            		    $loop++;
            		}else{
            			$this->NoError = 0;
            			$output[$pattern[$loop]] = $this->pagePtr;
            			if($this->debug)echo "templateScrape() - We're done, breaking out of this loop...<br>\n";
            		}
            		break;
                default:
                    $this->NoError = 0;
            }
            if(!$this->NoError){
                if($this->debug)echo "templateScrape() - NoError = ".$this->NoError."<br>\n";
                $loop = $end;
            }
        }
        //so now $output array is populated...
        if($this->debug)echo "templateScrape() - end output has ".count($output)." elements<br>\n";
        return $output;
	}

//New functions for parsing XML / HTML type data
    function getHTTP($url){
        $parsed = parse_url($url);
        $uri = 'http://';
        
        if (isset($parsed['pass'])) {
            $uri .= "$parsed[user]:$parsed[pass]@";
        } elseif (isset($parsed['user'])) {
            $uri .= "$parsed[user]@";
        }
        if (isset($parsed['host']))     $uri .= $parsed['host'];
        if (isset($parsed['port']))     $uri .= ":$parsed[port]";
        if (isset($parsed['path']))     $uri .= $parsed['path'];
        if (isset($parsed['query']))    $uri .= "?$parsed[query]";
        if (isset($parsed['fragment'])) $uri .= "#$parsed[fragment]";
        return agar_scraper::getFile($uri);
    }

    function getFile($fname){
        $fd=@fopen($fname,"r");
        if($fd){
            while ($line=@fgets($fd,1000))
             {
                $alltext.=$line;
             }
            fclose($fd);
        }
        return $alltext;
    }
    
    function getTags($search,$alltext){
        $output = array();
        $tags = explode("<",$alltext);
        for ($loop=1;$loop<count($tags);$loop++){
            $tag = explode(">",$tags[$loop]);
            if(stristr($tag[0],$search)){
                $tag[0] = str_replace("\t"," ",$tag[0]);
                $tag[0] = str_replace("\n"," ",$tag[0]);
                $tag[0] = str_replace("\r"," ",$tag[0]);
                $tag[0] = str_replace("\s"," ",$tag[0]);
                $tag[0] = str_replace("  "," ",$tag[0]);
                $tag[0] = str_replace("  "," ",$tag[0]);
                $tag[0] = str_replace("  "," ",$tag[0]);
                $tag[0] = str_replace("  "," ",$tag[0]);
                $tag[0] = str_replace("  "," ",$tag[0]);
//                echo "Tag[$loop]=".$tag[0]."<br>\n";
                $output[] = $tag[0];
            }
        }
        return $output;
    }
    
    function getPart($search,$tag){
        $parts = explode(" ",$tag);        
        $part = '';
        for($pLoop=0;$pLoop<count($parts);$pLoop++){
//            echo "Parts[$pLoop] = ".$parts[$pLoop]."<br>";
            
            if(stristr($parts[$pLoop],$search)){
                $part = explode("=",$parts[$pLoop]);
//                echo "<ul>".$part[0]." is ".str_replace("\"","",$part[1])."</ul>";
                return str_replace("\"","",$part[1]);
            }
        }
        return $part;
    }


}
?>