<?php
//////////////////////////////////////////////////////////////////////
// MyHeadlines v3.1.0, January 3, 2002
// by:  Mike Agar
//      myh_support@jmagar.com 
//      www.jmagar.com
//////////////////////////////////////////////////////////////////////
// This code is released under GPL refer to the included license.txt
//////////////////////////////////////////////////////////////////////
/*******************************************************************
		Source Data (STCK)
*******************************************************************/
$stck=1; //include protection

class STCK_ITEM {
	var $alias;
	var $symbol;
	var $value;
	var $change;
}

class agar_stck {
	var $stck_debug;
	var $stck_table_name;

//STATE MACHINE VARIABLES

/*********************************************************************************************
*** THIS MUST BE CALLED BEFORE ANY OTHER STCK FUNCTION !!!  ***********************************
**********************************************************************************************
	Required: Sets the database table name (pretty important)
	Optional: debug

*/
	function STCK_INIT($tableNamePrefix="AGAR_stck",$dbg=0){
		$this->stck_table_name=$tableNamePrefix; //MUST BE FIRST!!!
		$this->stck_debug = $dbg;
		
		//check to see if this table exisits... if not, create it.
		$result = mysql_query("show tables");
		while(list($name) = mysql_fetch_row($result)){
			if(stristr($name,$this->stck_table_name)){
				if($this->stck_debug)echo "STCK: is already Installed<br>\n";
				return;
			}
		}
		if($this->stck_debug)echo "STCK: Table NOT Found, need to build it!<br>\n";
		$this->createSTCKTables();
	}


	function addSTCK($alias,$symbol,$timeout=3600){ //one hour timeout by default
		$sd = $this->getSID($alias,$symbol);
		if(!$sd){
			$result = mysql_query("insert into $this->stck_table_name values(NULL,'$alias','$symbol','$timeout','$timeout','0','0')");
			$sd = mysql_insert_id();
		}
		return $sd;
	}


	function getSID($alias,$symbol="X_default_X"){

		if(strstr($symbol,"X_default_X")!==false){
			$query = "select sid from $this->stck_table_name where alias='$alias'";
		}else{
			$query = "select sid from $this->stck_table_name where alias='$alias' and symbol='$symbol'";
		}

		$result = mysql_query($query);
		if(mysql_num_rows($result)>0){
			list($sd) = mysql_fetch_row($result);
		}else{
			if($this->stck_debug)echo "STCK: getSID() - alias is not in the DB<br>\n";
			$sd=0;
		}
		return $sd;
	}


	function getVar($sd,$vname){
		$result = mysql_query("select $vname from $this->stck_table_name where sid='$sd'");
		if(mysql_num_rows($result)>0){
			list($rtn) = mysql_fetch_row($result);
		}else{
			if($this->stck_debug)echo "STCK: getVar() [$vname] - SID ($sd) is not in the DB<br>\n";
			$rtn="";
		}
		return $rtn;
	}


	function getStckInfo($sd){
		$rtn = new STCK_ITEM;
		$rtn->alias = $this->getAlias($sd);		
		$rtn->symbol = $this->getSymbol($sd);		
		$rtn->value = $this->getValue($sd);		
		$rtn->change = $this->getChange($sd);
		return $rtn;
	}


	function setStckInfo($sd,$sInfo){
		$this->setValue($sd,$sInfo->value);
		$this->setChange($sd,$sInfo->change);
		$this->touch($sd);
	}


	function getAlias($sd){
		return $this->getVar($sd,"alias");
	}

	function getSymbol($sd){
		return $this->getVar($sd,"symbol");
	}

	function getTimeout($sd){
		return $this->getVar($sd,"timeout");
	}

	function getChange($sd){
		return $this->getVar($sd,"current_change");
	}

	function getValue($sd){
		return $this->getVar($sd,"current_value");
	}

	function setVar($sd,$col,$value){
		$result = mysql_query("UPDATE $this->stck_table_name set $col='$value' where sid='$sd'");
	}

	function setAlias($sd,$input){
		$this->setVar($sd,"alias",$input);
	}

	function setSymbol($sd,$input){
		$this->setVar($sd,"symbol",$input);
	}

	function setValue($sd,$input){
		$this->setVar($sd,"current_value",$input);
	}

	function setChange($sd,$input){
		$this->setVar($sd,"current_change",$input);
	}

	function setTimeout($sd,$input){
		$this->setVar($sd,"timeout",$input);
	}

	function delSID($sd){
		$result = mysql_query("delete from $this->stck_table_name where sid='$sd'");
	}

//////////////////////////////////////////////////////////////////////////////////////////////////
//Timeouts Functions

	function isStale($sd){
		$rtn=0;
		$result = mysql_query("select lastupdate, timeout from $this->stck_table_name where sid='$sd'");
		if(mysql_num_rows($result)>0){
			list($lu,$to) = mysql_fetch_row($result);
			$now= time();
			$stale = $now - ($lu+$to);
			if($stale>0)$rtn=1;
		}
		return $rtn;
	}

	function listStale(){
		//returns an array of stale stocks.
		$now = time();
		$rtn = array();
		$query  = "SELECT sid";
		$query .= " FROM $this->stck_table_name s";
		$query .= " WHERE s.subscribers > 0";
		$query .= " AND ($now - (s.lastupdate + s.timeout))>0";
		$result = mysql_query($query);
		if($result){
			if($this->stck_debug)echo "listStale(): we may have one...<br>\n";
			if(mysql_num_rows($result)>0){
				while(list($sd)=mysql_fetch_row($result)){
					if($this->stck_debug)echo "listStale(): sid=$sd<br>\n";
					$rtn[] = $sd;					
				}
			}
		}
		return $rtn;
	}

	function untouchAll(){
		$result = mysql_query("update $this->stck_table_name set lastupdate='1'");
	}

	function touch($sd){
		$now = time();
		$result = mysql_query("update $this->stck_table_name set lastupdate='$now' where sid='$sd'");
	}

	function untouch($sd){
		$now = time();
		$result = mysql_query("update $this->stck_table_name set lastupdate='1' where sid='$sd'");
	}



/*******************************************************************************************
*** Admin Database Functions
*******************************************************************************************/
	function createSTCKTables(){
	//Master STCK Table
		$cmd =  "CREATE TABLE $this->stck_table_name (";
		$cmd .= "  sid int(11) DEFAULT '1' NOT NULL auto_increment,";
		$cmd .= "  alias text DEFAULT '' NOT NULL,";
		$cmd .= "  symbol text DEFAULT '' NOT NULL,";
		$cmd .= "  timeout int(11) NOT NULL,";
		$cmd .= "  lastupdate int(11) NOT NULL,";
		$cmd .= "  current_value text DEFAULT '' NOT NULL,";
		$cmd .= "  current_change text DEFAULT '' NOT NULL,";
		$cmd .= "  PRIMARY KEY (sid)";
		$cmd .= ")";
  	$err = mysql_query($cmd);
		$cmd =  "CREATE INDEX $this->stck_table_name"."_idx ON $this->stck_table_name (";
		$cmd .= "  alias (15)";
		$cmd .= ")";
  	$err = mysql_query($cmd);

	}

	function dropSTCKTables(){
		$err = mysql_query("drop index $this->stck_table_name"."_idx on $this->stck_table_name");
  	$err = mysql_query("drop table $this->stck_table_name");
	}
}
?>