<?php
//////////////////////////////////////////////////////////////////////
// Templates v1.0.0, February 6, 2003
// by:  Mike Agar
//      www.jmagar.com
//////////////////////////////////////////////////////////////////////
// This code is released under GPL refer to the included license.txt
//////////////////////////////////////////////////////////////////////

class myh_template {
	var $block;
	var $dashboard;
	var $subs;
	var $MYH_DEBUG;
	var $pd;
	
	//Cache Flags
	var $dBlck = true;
	var $dContent = true;
	var $dAdmin = true;

    //Templates
    var $dBWI;
    var $dBNI;
    var $dCH;
    var $dCI;
    var $dCF;
    var $dAS; //admin screen

	function myh_template($masterPD,$tableNamePrefix="AGAR_template",$dbg=0){
		$this->$MYH_DEBUG = $dbg;
		//init the PD
		$this->pd = new agar_pd;
		$this->pd->PD_INIT("$tableNamePrefix",$this->MYH_DEBUG);
        if(   ($this->pd->getValue("installed")==0)
            ||($this->pd->getValue("reset")!=0)
            ||($masterPD->getValue("reset_templates"))
//            ||true
            ){
            if($this->pd->getValue("defaultSkin")==0){
                $this->pd->setValue("defaultSkin","myhTemplates420");
            }
            $this->getDefaults($masterPD,$this->$MYH_DEBUG,$this->pd->getValue("defaultSkin"));    
    		$masterPD->setValue("reset_templates",0);
        }
	}
	
	function replace($search, $replace, $subject){
	   return  str_replace($search,$replace,$subject);
	}
	
	function dispBlock($box){
	    if($this->dBlck){
	        $this->dBlck = false;
	        $this->dBWI = $this->pd->getValue("dispBlockWithImage");
	        $this->dBNI = $this->pd->getValue("dispBlockNoImage");
	    }

	    if(strpos($box["image"],"1x1.gif")){
	        $out = $this->dBNI;
	    }else{
	        $out = $this->dBWI;
	    }

        $default_image = "<img src=\"{image_url}\"";
        if($box["image_override"]){
            $default_image .= " width=\"".$box["image_width"]."\"";
            
        }
        $default_image .= ">";
        
        $out = "<form action=\"".$box["promote_action"]."\" method=\"post\">".$out."</form>";
	    $out = $this->replace("{site_name}"     ,$box["title"],$out);
	    $out = $this->replace("{image}"         ,$default_image,$out);
	    $out = $this->replace("{image_url}"     ,$box["image"],$out);
	    $out = $this->replace("{content}"       ,$box["content"],$out);
	    $out = $this->replace("{url}"           ,$box["url"],$out);
	    $out = $this->replace("{next_update}"   ,$box["next_update"],$out);
	    $out = $this->replace("{more_link}"     ,$box["more_link"],$out);
	    $out = $this->replace("{subscribe_link}",$box["subscribe_link"],$out);
	    $out = $this->replace("{promote}"       ,$box["promote"],$out);
        return $out;
	}
	
	function getDashBoard($dbc,$isAdmin=0){
        if($isAdmin){
            $out = $this->pd->getValue("dispDashboardAdmin");
        }else{
            $out = $this->pd->getValue("dispDashboardUser");
        }
	    $out = $this->replace("{menu}",$dbc["menu"],$out);
	    $out = $this->replace("{stock_ticker}",$dbc["stock_ticker"],$out);
	    $out = $this->replace("{stock_ticker_js}",$dbc["stock_ticker_js"],$out);
	    $out = $this->replace("{user_subs}",$dbc["user_subs"],$out);
	    $out = $this->replace("{main_screen}",$dbc["main_screen"],$out);
	    return $out;
	}
	
	function userSubscriptionScreen($subLocations){
	    $out = $this->pd->getValue("dispUserSubs");
	    $out = $this->replace("{top_left}",$subLocations["lt"],$out);
	    $out = $this->replace("{top_center}",$subLocations["ct"],$out);
	    $out = $this->replace("{top_right}",$subLocations["rt"],$out);
	    $out = $this->replace("{bottom_left}",$subLocations["lb"],$out);
	    $out = $this->replace("{bottom_center}",$subLocations["cb"],$out);
	    $out = $this->replace("{bottom_right}",$subLocations["rb"],$out);
	    $out = $this->replace("{top_left_desc}",$subLocations["ltd"],$out);
	    $out = $this->replace("{top_center_desc}",$subLocations["ctd"],$out);
	    $out = $this->replace("{top_right_desc}",$subLocations["rtd"],$out);
	    $out = $this->replace("{bottom_left_desc}",$subLocations["lbd"],$out);
	    $out = $this->replace("{bottom_center_desc}",$subLocations["cbd"],$out);
	    $out = $this->replace("{bottom_right_desc}",$subLocations["rbd"],$out);
	    return $out;
	}

    function getAdminScreen($masterPD,$dbg=0){
        if($this->dAdmin){
            $screenName = "myhTemplatesAdmin420";
            if($this->pd->getValue("reset")){
                $this->getDefaults($masterPD,$dbg=0);
                $masterPD->setValue($screenName,0);
            }
            $screen = $masterPD->getValue($screenName);
            if($screen){
                $this->dAS = $screen;   
            }else{
                $rch = new rch_client();
                //Get Instance Key
                $ik = $masterPD->getValue("instanceKey");
                $ak = $masterPD->getValue("Template Admin Access Key");
                if(!$ik){
                    $ik = $rch->getInstanceKey();
                    $masterPD->setValue("instanceKey",$ik);
                }
                $this->dAS = $rch->getObject($screenName, $ik, $ak);            
            }
        }
        return $this->dAS;
    }

    function getContent($items,$numToShow,$showDesc,&$backend,$promote=0){

        if($this->dContent){//Cache this stuff, you'll you it a lot....
            $this->dContent = false;
            $this->dCH = $this->pd->getValue("dispContentHeader");
            $this->dCI = $this->pd->getValue("dispContentItem");
            $this->dCF = $this->pd->getValue("dispContentFooter");
        }

  		$rtn = $this->dCH;
        $itemCount = 0;
		while(list($cid,$iser, $timeout) = @current($items)){
			$itemCount++;
			$item = unserialize($iser);
			$item->link = $backend->getClickThruURL($cid);
            $item->title = $backend->unscrub($item->title);
            if($showDesc){
                $item->description = $backend->unscrub($item->description);
            }else{
                $item->description = "";
            }
            //Add a row, and replace
            $rtn .= $this->dCI;
       	    $rtn = $this->replace("{link}",$item->link,$rtn);
       	    $rtn = $this->replace("{title}",$item->title,$rtn);
       	    $rtn = $this->replace("{desc}",$item->description,$rtn);
       	    if($promote){
       	        $rtn = $this->replace("{checkbox}","<input type=checkbox name=myh_item[] value=$cid>",$rtn); 
       	    }else{
       	        $rtn = $this->replace("{checkbox}","",$rtn);
       	    }

			if($itemCount>=$numToShow){
			    //done, break the loop
			    end($items);
			}
			@next($items);
		}
  		$rtn .= $this->dCF;
        return $rtn;    
    }
	
	function getDefaults($masterPD,$dbg=0, $screenName="myhTemplates420" ){
	   global $myhPath;
        $rch = new rch_client();
        //Get Instance Key
        $ik = $masterPD->getValue("instanceKey");
        $ak = $masterPD->getValue("Template Admin Access Key");
        if(!$ik){
            $ik = $rch->getInstanceKey();
            $masterPD->setValue("instanceKey",$ik);
        }

        $this->pd->setValue("defaultSkin",$screenName);
        eval($rch->getObject($screenName, $ik, $ak));
	}

    
    function getValue($what){
        return $this->pd->getValue($what);
    }

    function setValue($what,$value){
       $this->pd->setValue($what,$value);
    }
    

}
?>