<?php
//////////////////////////////////////////////////////////////////////
// MyHeadlines v4.0.0, March 14, 2002
// by:  Mike Agar
//      www.jmagar.com
//////////////////////////////////////////////////////////////////////
// This code is released under GPL refer to the included license.txt
//////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
// Category Tree Globals
global $myh_CB_CatType, $myh_CB_cat, $myh_CB_src;

function myhCatTreeCallBack($eid,$tid){
	global $myh_CB_CatType, $myh_CB_cat, $myh_CB_src;
	
	$MYH_DEBUG = 0;
	
	if($MYH_DEBUG)echo "catTreeCallback(): (eid=$eid, tid=$tid)<br>\n";
	$rtn = "UNKNOWN TYPE ERROR (eid=$eid, tid=$tid)";
	switch($tid){
		case $myh_CB_CatType["cat"]:
			$rtn = $myh_CB_cat->getCAT($eid);
			break;
		case $myh_CB_CatType["usr"]:
		case $myh_CB_CatType["bad"]:
		case $myh_CB_CatType["src"]:
			$rtn = $myh_CB_src->getTitle($eid);
			break;
	}
	return $rtn;
}


function myhCatTreeAdminCallBack($eid,$tid){
	global $myh_CB_CatType, $myh_CB_cat, $myh_CB_src;
	
	$MYH_DEBUG = 0;
	
	if($MYH_DEBUG)echo "catTreeCallback(): (eid=$eid, tid=$tid)<br>\n";
	$rtn = "UNKNOWN TYPE ERROR (eid=$eid, tid=$tid)";
	switch($tid){
		case $myh_CB_CatType["cat"]:
			$rtn = $myh_CB_cat->getCAT($eid);
			break;
		case $myh_CB_CatType["usr"]:
		case $myh_CB_CatType["bad"]:
		case $myh_CB_CatType["src"]:
			$rtn = $myh_CB_src->getTitle($eid);
			$rtn .= " (".$myh_CB_src->getSubscribers($eid).")";
			break;
	}
	return $rtn;
}


/////////////////////////////////////////////////////////////////////
// Category Tree Object

class myh_cat_tree {
	
	var $myhCatType;
	var $myhCatIcon;
	var $MYH_DEBUG;
	var $myhURL;

	//Constructor
	function myh_cat_tree($dbg=0){
		$this->MYH_DEBUG = $dbg;
		$this->myhCatType = array();
		$this->myhCatIcon = array();
		$this->myhModURL = "";
		$idx="src";		$this->myhCatType[$idx]=30000;$this->myhCatIcon[$idx]=$idx." - ";
		$idx="bad";		$this->myhCatType[$idx]=20000;$this->myhCatIcon[$idx]=$idx." - ";
		$idx="usr";		$this->myhCatType[$idx]=19999;$this->myhCatIcon[$idx]=$idx." - ";
		$idx="cat";		$this->myhCatType[$idx]=10000;$this->myhCatIcon[$idx]=$idx." - ";
	}

	function INIT_CALLBACK($myh_cat,$myh_src){
		global $myh_CB_CatType, $myh_CB_cat, $myh_CB_src;
		//setup GTU call back (CB) globals
		$myh_CB_CatType=$this->myhCatType;
		$myh_CB_cat=$myh_cat;
		$myh_CB_src=$myh_src;
	}
	
	function INIT_URL_PREFIX($url){
		$this->myhURL = $url;	
	}

	///////////////////////////////////////////////////////////////////////
	// Category Path Functions
	
	function categoryPaths($myh_cat, $myh_gtu, $array,$index,$gid,$path=''){
	
		$tree = $myh_gtu->listNodes($gid);
		while(list($nid,$pid,$eid,$tid) = @current($tree)){
			if(!$myh_gtu->isRoot($nid)){
				switch($tid){
					case $this->myhCatType["cat"]:
					  $pname = $path;
						$pname .= $myh_cat->getCAT($eid);
						$array[$index]["name"]=$pname;
						$array[$index]["gid"]=$nid;
						$index++;
						break;
					default:
						break;
				}
	
				$children = $myh_gtu->listNodes($nid);
				if(is_array($children)
						&&!$myh_gtu->isRoot($nid)
						){
					$pname .= " | "; 
					$array = $this->categoryPaths($myh_cat, $myh_gtu, $array,$index,$nid,$pname);
					$index = count($array);
				}
			}
			next($tree);
			unset($children);
		}
		return $array;
	}
	
	function resetPathArray($myh_pd){
		$myh_pd->setValue("cat_path",0);
	}
	
	function getPathArray($myh_pd, $myh_gtu, $myh_cat){
		$cp = $myh_pd->getValue("cat_path");
		if($cp==0){
			//make the cat path...
			$myh_gtu->GTU_SELECT("cat");
			$rt = $myh_gtu->c_rid;
			$cp = $this->categoryPaths($myh_cat,$myh_gtu,$array,0,$rt);
			$myh_pd->setValue("cat_path",$cp);
		}
		return $cp;
	}
	
	/////////////////////////////////////////////////////////////////////
	// Tree functions... 
	function addCat($myh_gtu,$myh_cat,$name,$pid=0){
		$DEBUG = $myh_cat->cat_debug;
		$myh_gtu->GTU_SELECT("cat");
		if($pid==0)$pid=$myh_gtu->c_rid;
		$eid = $myh_cat->addCAT($name);
		if($eid){
			if($DEBUG)echo "addCat(): Passed - $name<br>\n";
			return $myh_gtu->addNode($pid,$eid,$this->myhCatType["cat"],myh_alpha_weight::weight($name));
		}else{
			//FAILURE
			if($DEBUG)echo "addCat(): FAILED - $name<br>\n";
			return 0;
		}
	}

	function renameCat($myh_gtu,$myh_cat,$name,$gid){
		$DEBUG = $myh_cat->cat_debug;
		$myh_gtu->GTU_SELECT("cat");
		if($pid==0)$pid=$myh_gtu->c_rid;
		$eid = $myh_cat->addCAT($name);
		if($eid){
			if($DEBUG)echo "renameCat(): Passed - $name<br>\n";
            //just renamed, must have new sort order
            $myh_gtu->modNodeWeight($gid,myh_alpha_weight::weight($name)); 
			return $myh_gtu->modNodeEID($gid,$eid);
		}else{
			//FAILURE
			if($DEBUG)echo "renameCat(): FAILED - $name<br>\n";
			return 0;
		}
	}
	
	function addHeadlineSrc($myh_gtu,$myh_src,$name,$url,$desc,$timeout,$isScraped,$template,$pid=0,$type=9998989){
		if($type==9998989)$type = $this->myhCatType["src"];
		$DEBUG = $this->MYH_DEBUG;//$myh_src->src_debug;
		$myh_gtu->GTU_SELECT("cat");
		if($pid==0)$pid=$myh_gtu->c_rid;
		$eid = $myh_src->addSRC($name, $desc, $url, $timeout,$isScraped,$template);
		if($eid){
			if($DEBUG)echo "<nobr>addHeadlineSrc(): Passed - $name, $url</nobr><br>\n";
			return $myh_gtu->addNode($pid,$eid,$type,myh_alpha_weight::weight($name));
		}else{
			//FAILURE
			if($DEBUG)echo "<nobr>addHeadlineSrc(): FAILED - $name, $url</nobr><br>\n";
			return 0;
		}
	}
	
	function addUserHeadlineSrc($myh_gtu,$myh_src,$myh_title,$myh_url,$myh_comment,$tout,$myh_dest){
		$this->addHeadlineSrc($myh_gtu,$myh_src,$myh_title,$myh_url,$myh_comment,$tout,0,'',$myh_dest,$this->myhCatType["usr"]);
	}
	
    function addSrc($myh_gtu,$name,$pid,$eid,$tid){
    	return $myh_gtu->addNode($pid,$eid,$tid,myh_alpha_weight::weight($name));
    }
	
	function isGoodSrc($myh_pd,$myh_gtu,$eid){
		if($myh_pd->getValue("bad_strike_count".$eid)>=10){ //stop trying to fix it after 10 consecutive attempts
			return 0;
		}else{
			return 1;
		}
	}
	
	
	function goodSrc($myh_pd,$myh_gtu,$myh_src,$eid,$override=0){
		if($myh_pd->getValue("bad_strike_count".$eid)||$override){
			$myh_pd->setValue("bad_strike_count".$eid,0);
			$this->markSrc($myh_gtu,$eid,$this->myhCatType["src"]);
		}
	}
	
	function badSrc($myh_pd,$myh_gtu,$myh_src,$eid,$forced=0){
		//count of strike increment, and if threshold met, mark bad...
		$strikes = (int)$myh_pd->getValue("consecutive_failures_before_bad");
		$current = 1 + (int)$myh_pd->getValue("bad_strike_count".$eid);
		if(($current > $strikes)||$forced){
			$this->markSrc($myh_gtu,$eid,$this->myhCatType["bad"]);
		}
		$myh_pd->setValue("bad_strike_count".$eid,$current);
	}
	
	function markSrc($myh_gtu,$eid,$type){
		//walk the tree and make all eid to "src"
		//Making this source good
		$myh_gtu->GTU_SELECT("cat");
		if($this->MYH_DEBUG)echo "Marking this source ($eid) as = $type<br>";
		$nodes = $myh_gtu->findNodes($eid,$this->myhCatType["src"]);
		$end = count($nodes);
		for($loop=0;$loop<$end;$loop++){
			$myh_gtu->modNodeTID($nodes[$loop],$type);
		}
		$nodes = $myh_gtu->findNodes($eid,$this->myhCatType["bad"]);
		$end = count($nodes);
		for($loop=0;$loop<$end;$loop++){
			$myh_gtu->modNodeTID($nodes[$loop],$type);
		}
		$nodes = $myh_gtu->findNodes($eid,$this->myhCatType["usr"]);
		$end = count($nodes);
		for($loop=0;$loop<$end;$loop++){
			$myh_gtu->modNodeTID($nodes[$loop],$type);
		}
	}
	
	function delAllHeadlineEntries($myh_gtu,$sd){
		$myh_gtu->GTU_SELECT("cat");
		$rid = $myh_gtu->c_rid;
		$myh_gtu->delAllMatchingNodes($rid,$sd,$this->myhCatType["src"]);
		$myh_gtu->delAllMatchingNodes($rid,$sd,$this->myhCatType["usr"]);
		$myh_gtu->delAllMatchingNodes($rid,$sd,$this->myhCatType["bad"]);
	}
	

	function delAllBadSrc($myh_gtu){
		$myh_gtu->GTU_SELECT("cat");
		$myh_gtu->delAllOfType($this->myhCatType["bad"]);
	}
	

    function isSrcInTree($myh_gtu,$sid){
        $srcs = $this->listAllSrcs($myh_gtu);
        if(in_array($sid,$srcs,false))return true;
        return false;
    }


    function listAllSrcs($myh_gtu){
		$myh_gtu->GTU_SELECT("cat");
        $out = array();
        $src = $myh_gtu->listAllOfType($this->myhCatType["src"]);
        $usr = $myh_gtu->listAllOfType($this->myhCatType["usr"]);
        $bad = $myh_gtu->listAllOfType($this->myhCatType["bad"]);
        if($this->MYH_DEBUG)echo " CAT *** Count Src = ".count($src)."<br>"; 
        if($this->MYH_DEBUG)echo " CAT *** Count Usr = ".count($usr)."<br>"; 
        if($this->MYH_DEBUG)echo " CAT *** Count Bad = ".count($bad)."<br>"; 
        $out = array_values(array_merge($src,$usr));
        $out = array_values(array_merge($out,$bad));
        $out = array_values(array_unique($out));
        if($this->MYH_DEBUG)echo " CAT *** Count Out = ".count($out)."<br>"; 
        return $out;
    }
	
	/////////////////////////////////////////////////////////////////////
	// IMPORT / EXPORT functions... 
    function myhExportPath($myh_gtu,$nid){
        $myh_gtu->GTU_SELECT("cat");
	    
        if(!$myh_gtu->isRoot($nid)){
            $output = $this->myhExportPath($myh_gtu,$myh_gtu->getNodePID($nid));
        }else{
            return;
        }
        $catName = myhCatTreeCallBack($myh_gtu->getNodeEID($nid),$myh_gtu->getNodeTID($nid));

        $output = $output."<d></d>".$catName;
        return $output;
    }
    
    function myhExportInclude($url,$include){
        if(strlen($include)>0){
            //we have an include list...
            $hosts = explode(",",$include);
            if(!is_array($hosts)){
                $hosts = array();
                $hosts[]=$include;
            }
            $end = count($hosts);
            for($loop=0;$loop<$end;$loop++){
                //check to see if the $hosts[$loop] is in the url
                if (stristr($url,$hosts[$loop])!==false) {
                    return 1;
                }
            }
            return 0;
        }else{
            return 1;
        }
    }
    
    function myhExportExclude($url,$exclude){
        if(strlen($exclude)>0){
            //we have an exclude list...
            $hosts = explode(",",$exclude);
            if(!is_array($hosts)){
                $hosts = array();
                $hosts[]=$exclude;
            }
            $end = count($hosts);
            for($loop=0;$loop<$end;$loop++){
                //check to see if the $hosts[$loop] is in the url
                if (stristr($url,$hosts[$loop])!==false) {
                    return 1;
                }
            }
            return 0;
        }else{
            return 0;
        }
    }



	function myhExport($myh_gtu,$myh_src,$myh_cat,$include,$exclude,$root=0,$scraped_only=0){
	    $max_per_cat = 5;
	    $src_cnt = 0;
	    $output = "";
	    $firstSrc = 1;
	    $myh_gtu->GTU_SELECT("cat");
	    if($root==0)$root = $myh_gtu->c_rid;
    	$node = $myh_gtu->listNodes($root);
        while(list($nid,$pid,$eid,$tid) = @current($node)){
	        if(!$myh_gtu->isRoot($nid)){
            	if($myh_gtu->isDrillable($nid)){
                    //this is a category, keep diggin'
                    //echo "<ul>we are here <b>$nid</b><br>";
                    $output .= $this->myhExport($myh_gtu,$myh_src,$myh_cat,$include,$exclude,$nid,$scraped_only);
   	    		    //echo "</ul>";
   	    		}else{
       	    		if($tid==$this->myhCatType["src"]){//only export good sources
       	    		    $url = $myh_src->getURL($eid);
       	    		    if($scraped_only){
       	    		        //Only scraped feeds = must be scraped
       	    		        $scraper_test=$myh_src->isScraped($eid);
       	    		    }else{
       	    		        //don't care state
       	    		        $scraper_test=true;
       	    		    }
       	    		    if(($this->myhExportInclude($url,$include))&&(!$this->myhExportExclude($url,$exclude))&&$scraper_test){
           	    		    //echo "we are now here <b>$nid</b><br>";
                            if($src_cnt>$max_per_cat){
                                //close the category and reopen it...(possible stack overflow in import side...)
                                $output .= "</cat>\n";
                        	    $firstSrc = 1; //start over with this one...
                        	    $src_cnt=0;
                            }else{
                                $src_cnt++;
                            }
           	    		    //got a headline...    
           	    		    if($firstSrc){
           	    		        $firstSrc = 0;
                                $output .= "<cat>\n<path>\n";
           	    		        $output .= $this->myhExportPath($myh_gtu,$pid);
                                $output .= "\n</path>\n";
           	    		    }
           	    		    //now do the headline...
                            
           	    		    $output .= "<src>\n";
           	    		    $output .= "<name>\n";
                            $output .= $myh_src->getTitle($eid);
           	    		    $output .= "\n</name>\n";
           	    		    $output .= "<url>\n";
                            $output .= $url;
           	    		    $output .= "\n</url>\n";
           	    		    $output .= "<desc>\n";
                            $output .= $myh_src->getComment($eid);
           	    		    $output .= "\n</desc>\n";
           	    		    $output .= "<timeout>\n";
                            $output .= $myh_src->getTimeout($eid);
           	    		    $output .= "\n</timeout>\n";
           	    		    $output .= "<scraped>\n";
                            $output .= $myh_src->isScraped($eid);
           	    		    $output .= "\n</scraped>\n";
           	    		    $output .= "<template>\n";
                            $output .= $myh_src->getTemplate($eid,0);
           	    		    $output .= "\n</template>\n";
           	    		    $output .= "</src>\n";
       	    		    }//end include test
       	    		}//is this a src
   	    		}//end else (not drillable)
	        }//end isRoot
            next($node);
        }
        if(!$firstSrc){
            //we found something, so cap off the cat...   
            $output .= "</cat>\n";
        }
        return $output;
	}
	
	
	function myhImport($myh_gtu,$myh_src,$myh_cat,$fbuffer,$xpid=0){
		$catChunks = explode("<cat>",$fbuffer);
		$catCount = count($catChunks);
		for($cLoop=0;$cLoop<$catCount;$cLoop++){
			//Build path
			$pid = $xpid;
			ereg("<path>(.*)</path>",$catChunks[$cLoop],$temp);
			$path = ereg_replace("</path>.*","",$temp[1]);
			$pathChunks = explode("<d></d>",$path);
			$pathCount = count($pathChunks);
			if($this->MYH_DEBUG)echo "<nobr>myhImport(): path = $path</nobr><br>\n";  
			if($pathCount==0){
				//build an array just incase there aren't any delimiters
				if($this->MYH_DEBUG)echo "<nobr>myhImport(): pathCount == 0, Constructing pathChunks[0] = $path</nobr><br>\n";  
				$pathChunks = array();
				$pathChunks[0] = $path;
				$pathCount = count($pathChunks);
			}
			for($pLoop=$pStart;$pLoop<$pathCount;$pLoop++){
				if(strlen(trim($pathChunks[$pLoop]))>0){
					$tp = trim($pathChunks[$pLoop]);
					$pid = $this->addCat($myh_gtu,$myh_cat,$tp,$pid);
				}else{
					if($this->MYH_DEBUG)echo "<nobr>myhImport(): pathChunk[$pLoop] is too short ($pathChunk[$pLoop])</nobr><br>\n";  
				}
			}//pLoop
			//Add sources
			$srcChunks = explode("<src>",$catChunks[$cLoop]);
			$srcCount = count($srcChunks);
			for($sLoop=1;$sLoop<$srcCount;$sLoop++){
				$timeout=4000;//$type=$myhCatType[src];
				$name = $desc = $url = ""; $timeout = 6*3600; //$type = 300;
				$scraped = 0; $template = "";
				//site name
				ereg("<name>(.*)</name>",$srcChunks[$sLoop],$temp);
				$name = ereg_replace("</name>.*","",$temp[1]);
				//url
				ereg("<url>(.*)</url>",$srcChunks[$sLoop],$temp);
				$url = ereg_replace("</url>.*","",$temp[1]);
				//description
				if(ereg("<desc>(.*)</desc>",$srcChunks[$sLoop],$temp)){
    				$desc = ereg_replace("</desc>.*","",$temp[1]);
				}
				//timeout
				if(ereg("<timeout>(.*)</timeout>",$srcChunks[$sLoop],$temp)){
    				$num = trim(ereg_replace("</timeout>.*","",$temp[1]));
    				if(is_int((int)$num)){
    					$timeout = (int)$num;
    				}
				}
				//type
				if(ereg("<type>(.*)</type>",$srcChunks[$sLoop],$temp)){
    				$num = ereg_replace("</type>.*","",$temp[1]);
    				if(is_int($num)){
    					$type = $num;
    				}
				}
				//scraped
				if(ereg("<scraped>(.*)</scraped>",$srcChunks[$sLoop],$temp)){
    				$num = trim(ereg_replace("</scraped>.*","",$temp[1]));
    				if(is_int((int)$num)){
    					$scraped = (int)$num;
    				}
				}
				//template
				if(ereg("<template>(.*)</template>",$srcChunks[$sLoop],$temp)){
    				$template = ereg_replace("</template>.*","",$temp[1]);
				}
				if((strlen($name)>1)&&(strlen($url)>3)){
	//TODO: deal with different types...
					$gid = $this->addHeadlineSrc($myh_gtu,$myh_src,trim($name),trim($url),trim($desc),$timeout,$scraped,trim($template),$pid,$this->myhCatType["src"]);
				}
			}//sLoop
		}//cLoop
	}
	
	function myhUnImport($myh_gtu,$myh_src,$myh_cat,$fbuffer,$xpid=0){
		$catChunks = explode("<cat>",$fbuffer);
		$catCount = count($catChunks);
		for($cLoop=0;$cLoop<$catCount;$cLoop++){
			//Build path
			$pid = $xpid;
			ereg("<path>(.*)</path>",$catChunks[$cLoop],$temp);
			$path = ereg_replace("</path>.*","",$temp[1]);
			$pathChunks = explode("<d></d>",$path);
			$pathCount = count($pathChunks);
			if($this->MYH_DEBUG)echo "<nobr>myhUnImport(): path = $path</nobr><br>\n";  
			if($pathCount==0){
				//build an array just incase there aren't any delimiters
				if($this->MYH_DEBUG)echo "<nobr>myhUnImport(): pathCount == 0, Constructing pathChunks[0] = $path</nobr><br>\n";  
				$pathChunks = array();
				$pathChunks[0] = $path;
				$pathCount = count($pathChunks);
			}
			for($pLoop=$pStart;$pLoop<$pathCount;$pLoop++){
				if(strlen(trim($pathChunks[$pLoop]))>0){
					$tp = trim($pathChunks[$pLoop]);
					$pid = $this->addCat($myh_gtu,$myh_cat,$tp,$pid);
				}else{
					if($this->MYH_DEBUG)echo "<nobr>myhUnImport(): pathChunk[$pLoop] is too short ($pathChunk[$pLoop])</nobr><br>\n";  
				}
			}//pLoop
			//Add sources
			$srcChunks = explode("<src>",$catChunks[$cLoop]);
			$srcCount = count($srcChunks);
			for($sLoop=1;$sLoop<$srcCount;$sLoop++){
				$timeout=4000;//$type=$myhCatType[src];
				$name = $desc = $url = ""; $timeout = 6*3600; //$type = 300;
				$scraped = 0; $template = "";
				//site name
				ereg("<name>(.*)</name>",$srcChunks[$sLoop],$temp);
				$name = ereg_replace("</name>.*","",$temp[1]);
				//url
				ereg("<url>(.*)</url>",$srcChunks[$sLoop],$temp);
				$url = ereg_replace("</url>.*","",$temp[1]);
				//description
				if(ereg("<desc>(.*)</desc>",$srcChunks[$sLoop],$temp)){
    				$desc = ereg_replace("</desc>.*","",$temp[1]);
				}
				//timeout
				if(ereg("<timeout>(.*)</timeout>",$srcChunks[$sLoop],$temp)){
    				$num = trim(ereg_replace("</timeout>.*","",$temp[1]));
    				if(is_int((int)$num)){
    					$timeout = (int)$num;
    				}
				}
				//type
				if(ereg("<type>(.*)</type>",$srcChunks[$sLoop],$temp)){
    				$num = ereg_replace("</type>.*","",$temp[1]);
    				if(is_int($num)){
    					$type = $num;
    				}
				}
				//scraped
				if(ereg("<scraped>(.*)</scraped>",$srcChunks[$sLoop],$temp)){
    				$num = trim(ereg_replace("</scraped>.*","",$temp[1]));
    				if(is_int((int)$num)){
    					$scraped = (int)$num;
    				}
				}
				//template
				if(ereg("<template>(.*)</template>",$srcChunks[$sLoop],$temp)){
    				$template = ereg_replace("</template>.*","",$temp[1]);
				}
				if((strlen($name)>1)&&(strlen($url)>3)){
	//TODO: deal with different types...
					$gid = $this->addHeadlineSrc($myh_gtu,$myh_src,trim($name),trim($url),trim($desc),$timeout,$scraped,trim($template),$pid,$this->myhCatType["src"]);
                    $err = $myh_gtu->delNode($gid);
//					$un_sid = $myh_gtu->getNodeEID($gid);
//					$this->delAllHeadlineEntries($myh_gtu,$un_sid);
				}
			}//sLoop
		}//cLoop
		$this->pruneTree($myh_gtu);
	}
	
	function pruneTree($myh_gtu,$root=0){
	    $myh_gtu->GTU_SELECT("cat");
	    if($root==0)$root = $myh_gtu->c_rid;
    	$node = $myh_gtu->listNodes($root);
        while(list($nid,$pid,$eid,$tid) = @current($node)){
	        if(!$myh_gtu->isRoot($nid)){
	            if($tid==$this->myhCatType["cat"]){
	                //category
    	        	if($myh_gtu->isDrillable($nid)){
                        //this is a category, keep diggin'
                        //echo "<ul>we are here <b>$nid</b><br>";
                        $this->pruneTree($myh_gtu,$nid);
       	    		    //echo "</ul>";
       	    		}
       	    		if(!($myh_gtu->isDrillable($nid))){
       	    		    $myh_gtu->delNode($nid);
       	    		}
	            }else{
	                //not a category... find out if it is a funky src (no name)
	                if(strlen(myhCatTreeCallBack($eid,$tid))<1){
	                    $myh_gtu->delNode($nid);
	                }
	            }
	        }//end isRoot
            next($node);
        }
        return;
	}
	
	/////////////////////////////////////////////////////////////////////
	// Utility functions... 
	
	
	function buildPath($myh_gtu,$myh_cat,$pid){
		//head back to the root
		if($myh_gtu->isRoot($pid)){
			//at the root start heading back
			return "";
		}else{
			//head north
			$head = $this->buildPath($myh_gtu,$myh_cat,$myh_gtu->getNodePID($pid));
			//concat this category name
			$head .= "<d></d>";
			$head .= $myh_cat->getCAT($myh_gtu->getNodeEID($pid));
			if($this->MYH_DEBUG)echo "buildPath(): $head<br>\n";
			return $head;
		}
	}
	
	function getPath($myh_gtu,$myh_cat,$gid){
		$tid = $myh_gtu->getNodeTID($gid);
		switch($tid){
			case $this->myhCatType["cat"]:
				$pid = $gid;
				break;
			case $this->myhCatType["bad"]:
			case $this->myhCatType["src"]:
				$pid = $myh_gtu->getNodePID($gid);
				break;
		}
		$path = $this->buildPath($myh_gtu,$myh_cat,$pid);
		
		return $path;
	}
	
	function selectDestCategory($myh_pd,$myh_gtu,$myh_cat,$myhLang,$pid=0){
		$myh_gtu->GTU_SELECT("cat");
		$rt = $myh_gtu->c_rid;
		$output = "<select name=myh_dest size=1>\n";
		if(!$pid){
			$output .= "<option selected value=".$rt.">".$myhLang["base"]."</option>\n";
		}else{
			$output .= "<option value=".$rt.">".$myhLang["base"]."</option>\n";
		}
		$path = $this->getPathArray($myh_pd,$myh_gtu,$myh_cat);
		$num = count($path);
		for($loop=0;$loop<$num;$loop++){
			if($gid!=$path[$loop]["gid"]){//can't select yourself...
				if($pid == $path[$loop]["gid"]){
					$output .= "<option selected value=".$path[$loop]["gid"].">".$path[$loop]["name"]."</option>\n";
				}else{
					$output .= "<option value=".$path[$loop]["gid"].">".$path[$loop]["name"]."</option>\n";
				}
			}
		}
		$output .= "</select>\n";
		return $output;
	}
	
	
	/////////////////////////////////////////////////////////////////////
	// Show Tree functions... 
	function listBadSources($myh_gtu,$myhLang){
		if($this->MYH_DEBUG)echo "listBadSources(): ".$this->myhCatType["bad"]."<br>\n";
		$output = "<b>".$myhLang["bad_srcs"].":</b>\n";
		$output .= $this->listSources($myh_gtu,$this->myhCatType["bad"],$myhLang);
		return $output;
	}
	
	function listNewSources($myh_gtu,$myhLang){
		if($this->MYH_DEBUG)echo "listNewSources(): ".$this->myhCatType["usr"]."<br>\n";
		$output =  "<b>".$myhLang["new_srcs"].":</b>\n";
		$output .= $this->listSources($myh_gtu,$this->myhCatType["usr"],$myhLang);
		return $output;
	}
	
	function listSources($myh_gtu,$etid,$myhLang){
		global  $context, $meid;
		if($this->MYH_DEBUG)echo "listSources(): $etid<br>\n";
		$tmpURL = $this->myhURL."&meid=".$meid."&myh=admin&myh_op=test1";
		$commands[$myhLang["Delete"]] = $this->myhURL."&meid=".$meid."&myh=admin&myh_op=deleteHead&myh_allofthem=1";
		$myh_gtu->GTU_SELECT("cat","show_2");
		return $myh_gtu->showListOfNodes($etid, $tmpURL, $context,$commands);
	}
	
	
	function showCatSubscribeTree($myh_pd,$myh_gtu,$meid,$myhLang,$dpid=0){
		global $context, $myhPath;
		if(!($myh_pd->getValue("cat_show_1"))){
			//init this view
			$myh_gtu->GTU_SELECT("cat","show_1");
			$myh_gtu->setGetTextCallBack("myhCatTreeCallBack");
			//defaults
			$myh_gtu->setTypeID($this->myhCatType["src"]);
			$myh_gtu->setTypeID($this->myhCatType["cat"]);
			$myh_gtu->setTypeID($this->myhCatType["bad"]);
			$myh_gtu->setTypeID($this->myhCatType["usr"]);
			//Visible
			//HIDE the BAD Sources: (and new submissions) 
			$myh_gtu->setVisible($this->myhCatType["bad"],0);
			$myh_gtu->setVisible($this->myhCatType["usr"],0);
			//icons
			$myh_gtu->setIcon($this->myhCatType["cat"],"<img src=\"$myhPath/images/folder.gif\" border=0>");
		//	$myh_gtu->setIcon($this->myhCatType["src"],"<img src=\"$myhPath/images/news_icon.gif\">");
			//url
			$tempURL = $this->myhURL."&meid=".$meid."&myh=menu";
			$myh_gtu->setURL($this->myhCatType["cat"],$tempURL);
			$tempURL = $this->myhURL."&meid=".$meid."&myh=user&myh_op=sub1";
			$myh_gtu->setURL($this->myhCatType["src"],$tempURL);
			//turn on flag
			$myh_pd->setValue("cat_show_1",1);
		}
		$myh_gtu->GTU_SELECT("cat","show_1");
		return "<b>".$myhLang["Sources"]."</b><br>".$myh_gtu->drawContextTree($dpid,0,$context);
	}

//TODO: unset these if the lang changes!!!	

	function showAdminCatTree($myh_pd,$myh_gtu,$myhLang,$meid){
		global $context, $myhPath;
		if(!($myh_pd->getValue("cat_show_2"))){
			//init this view
			$myh_gtu->GTU_SELECT("cat","show_2");
			$myh_gtu->setGetTextCallBack("myhCatTreeAdminCallBack");
			//defaults
			$myh_gtu->setTypeID($this->myhCatType["src"]);
			$myh_gtu->setTypeID($this->myhCatType["cat"]);
			$myh_gtu->setTypeID($this->myhCatType["bad"]);
			$myh_gtu->setTypeID($this->myhCatType["usr"]);
			//Visible
			//icons
			$myh_gtu->setIcon($this->myhCatType["cat"],"<img src=\"$myhPath/images/folder.gif\"  border=0>");
		//	$myh_gtu->setIcon($this->myhCatType["src"],"<img src=\"$myhPath/images/news_icon.gif\">");
			$myh_gtu->setIcon($this->myhCatType["bad"],$myhLang["Bad"]." - ");
			$myh_gtu->setIcon($this->myhCatType["usr"],$myhLang["New"]." - ");
			//url
			$tempURL = $this->myhURL."&meid=".$meid."&myh=menu";
			$myh_gtu->setURL($this->myhCatType["cat"],$tempURL);
			$tempURL = $this->myhURL."&meid=".$meid."&myh=admin&myh_op=edit1";
			$myh_gtu->setURL($this->myhCatType["src"],$tempURL);
			//actions...
			$tmpURL = $this->myhURL."&meid=".$meid."&myh=admin&myh_op=copy1";
			$myh_gtu->addAction($this->myhCatType["src"],$myhLang["Copy"],$tmpURL);
			$myh_gtu->addAction($this->myhCatType["cat"],$myhLang["Copy"],$tmpURL);
			$tmpURL = $this->myhURL."&meid=".$meid."&myh=admin&myh_op=test1";
			$myh_gtu->addAction($this->myhCatType["bad"],$myhLang["Test"],$tmpURL);
			$myh_gtu->addAction($this->myhCatType["usr"],$myhLang["Test"],$tmpURL);
			$tmpURL = $this->myhURL."&meid=".$meid."&myh=admin&myh_op=del1";
			$myh_gtu->addAction($this->myhCatType["src"],$myhLang["Delete"],$tmpURL);
			$myh_gtu->addAction($this->myhCatType["bad"],$myhLang["Delete"],$tmpURL);
			$myh_gtu->addAction($this->myhCatType["usr"],$myhLang["Delete"],$tmpURL);
			$myh_gtu->addAction($this->myhCatType["cat"],$myhLang["Delete"],$tmpURL);
			$tmpURL = $this->myhURL."&meid=".$meid."&myh=admin&myh_op=rename";
			$myh_gtu->addAction($this->myhCatType["cat"],$myhLang["Rename"],$tmpURL);
			$tmpURL = $this->myhURL."&meid=".$meid."&myh=admin&myh_op=defSub";
			$myh_gtu->addAction($this->myhCatType["src"],$myhLang["Default"],$tmpURL);
			$tmpURL = $this->myhURL."&meid=".$meid."&myh=admin&myh_op=defSect";
			$myh_gtu->addAction($this->myhCatType["src"],$myhLang["defSect"],$tmpURL);
			$tmpURL = $this->myhURL."&meid=".$meid."&myh=admin&myh_op=info";
			$myh_gtu->addAction($this->myhCatType["src"],$myhLang["Info"],$tmpURL);
			$myh_gtu->addAction($this->myhCatType["bad"],$myhLang["Info"],$tmpURL);
			$myh_gtu->addAction($this->myhCatType["usr"],$myhLang["Info"],$tmpURL);
			//turn on flag
			$myh_pd->setValue("cat_show_2",1);
			$myh_gtu->sortTree();
		}
		$myh_gtu->GTU_SELECT("cat","show_2");
		return "<b>".$myhLang["Sources"]."</b><br>".$myh_gtu->drawContextTree(0,0,$context);
	}
}
?>