<?php
//////////////////////////////////////////////////////////////////////
// MyHeadlines v4.0.0, March 14, 2002
// by:  Mike Agar
//      www.jmagar.com
//////////////////////////////////////////////////////////////////////
// This code is released under GPL refer to the included license.txt
//////////////////////////////////////////////////////////////////////

global $myh_CB_user_types, $myh_CB_act, $myh_CB_src, $myh_CB_stck, $myh_CB_Lang;

function myhUserTreeCallBack($eid,$tid){
	global $myh_CB_user_types, $myh_CB_act, $myh_CB_src, $myh_CB_stck, $myh_CB_Lang;
	
	$DEBUG = 0;

	if($DEBUG)echo "userTreeCallBack(): (eid=$eid, tid=$tid)<br>\n";
	$rtn = "UNKNOWN TYPE ERROR (eid=$eid, tid=$tid)";
	switch($tid){
		case $myh_CB_user_types["cat10"]:
			$rtn = $myh_CB_Lang["RegUsers"];
			break;
		case $myh_CB_user_types["cat20"]:
			$rtn = $myh_CB_Lang["AnonUsers"];
			break;
		case $myh_CB_user_types["cat29"]:
			$rtn = $myh_CB_Lang["SiteDefault"];
			break;
		case $myh_CB_user_types["usr"]:
			if($eid==0){
				$rtn = $myh_CB_Lang["Default"];
			}else{
				$rtn = $myh_CB_act->getName($eid);
			}
			break;
		case $myh_CB_user_types["plc"]:
			$idx = "Place".$eid;
			$rtn = $myh_CB_Lang[$idx];
			break;
		case $myh_CB_user_types["src"]:
			$rtn = $myh_CB_src->getTitle($eid);
			break;
		case $myh_CB_user_types["stck"]:
			$rtn = $myh_CB_stck->getAlias($eid);
			break;
	}
	return $rtn;
}



class myh_user_tree {
	var $myh_user_types;
	var $myh_user_place;
	var $MYH_DEBUG;
	var $myhURL;
	
	function myh_user_tree($myh_pd,$dbg=0){
		$this->myh_user_types = array();
		$this->myh_user_place = array();
		$this->MYH_DEBUG = $dbg;
		$this->myhURL="";
		$this->myh_user_types["cat10"]	= 10;	//Users
		$this->myh_user_types["cat20"]	= 20;	//Anonymous
		$this->myh_user_types["cat29"]	= 29;	//Site Default
		$this->myh_user_types["usr"] 	= 30;	//name
		$this->myh_user_types["plc"] 	= 35;	//placement
		$this->myh_user_types["src"] 	= 40;   //item
		$this->myh_user_types["stck"]	= 50;	//Stock Symbol
		$this->myh_user_place["lt"]=1;
		$this->myh_user_place["rt"]=2;
		$this->myh_user_place["lb"]=3;
		$this->myh_user_place["rb"]=4;
		if($myh_pd->getValue("enable_center_blocks")){
			$this->myh_user_place["ct"]=5;
			$this->myh_user_place["cb"]=6;
		}
		$this->myh_user_place["st"]=9;    //stock ticker will have it's own block
	}
	
	function INIT_CALLBACK($myh_act,$myh_src,$myh_stck,$myhLang){
		global $myh_CB_user_types, $myh_CB_act, $myh_CB_src, $myh_CB_stck, $myh_CB_Lang;

		$myh_CB_user_types = $this->myh_user_types;
		$myh_CB_act = $myh_act;
		$myh_CB_src = $myh_src; 
		$myh_CB_stck = $myh_stck;
		$myh_CB_Lang = $myhLang;
	}

	function INIT_URL_PREFIX($url){
		$this->myhURL = $url;	
	}

	
	function myhPlacementForm($myhLang,$current=1){
		$end = count($this->myh_user_place)-1; // don't include the stock ticker
		$output = "<select name=\"myh_plc\" size=\"1\">\n";
		for($loop=1; $loop<=$end; $loop++){
			$output .=  "<option ";
			if($loop==$current)$output .= "selected ";
			$idx = "Place".$loop;
			$output .= "value=\"$loop\" >".$myhLang[$idx]."</option>\n";
	
		}
		$output .=  "</select>\n";
		return $output;
	}
	
	
	///////////////////////////////////////////////////////////////////
	// User Tree Functions
	function addSubscription($myh_gtu,$myh_act,$myh_src,$place=99,$default=0){
		global $eid;
		$uid = $myh_act->uid;
		$myh_gtu->GTU_SELECT("user");
		$rid = $myh_gtu->c_rid;
		$tid = $this->myh_user_types["cat10"];
		if($myh_act->isAnon){
			//Anon User..
			$tid = $this->myh_user_types["cat20"];
		}
		if($default){
			$tid = $this->myh_user_types["cat29"];
			$uid = 0;
		}
		$pid = $myh_gtu->addNode($rid,$tid,$tid);
		$pid = $myh_gtu->addNode($pid,$uid,$this->myh_user_types["usr"]);
		$pid = $myh_gtu->addNode($pid,$place,$this->myh_user_types["plc"]);
		$gid = $myh_gtu->addNode($pid,$eid,$this->myh_user_types["src"]);
		//increment count on the source
		$myh_src->incSubscribers($eid);
	}
	
	function addStock($myh_gtu,$myh_act,$myh_stck,$sd,$default=0){
		$uid = $myh_act->uid;
		$myh_gtu->GTU_SELECT("user");
		$rid = $myh_gtu->c_rid;
		$tid = $this->myh_user_types["cat10"];
		if($myh_act->isAnon){
			//Anon User..
			$tid = $this->myh_user_types["cat20"];
		}
		if($default){//Mandatory
			$tid = $this->myh_user_types["cat29"];
			$uid = 0;
		}
		$eid = $sd;
		$pid = $myh_gtu->addNode($rid,$tid,$tid);
		$pid = $myh_gtu->addNode($pid,$uid,$this->myh_user_types["usr"]);
		$pid = $myh_gtu->addNode($pid,$this->myh_user_place["st"],$this->myh_user_types["plc"]);
		$gid = $myh_gtu->addNode($pid,$eid,$this->myh_user_types["stck"]);
	}
	
    function delAllAnonSubscriptions($myh_gtu){
		$myh_gtu->GTU_SELECT("user");
		$rid = $myh_gtu->c_rid;
		$tid = $this->myh_user_types["cat20"];        
		$pid = $myh_gtu->addNode($rid,$tid,$tid);
		$err = $myh_gtu->delNode($pid,1);
    }
	
	function delAllUserSubscriptions($myh_gtu,$myh_src,$sd){
		$myh_gtu->GTU_SELECT("user");
		$rid = $myh_gtu->c_rid;
		$myh_gtu->delAllMatchingNodes($rid,$sd,$this->myh_user_types["src"]);
		$myh_src->resetSubscribers($sd);
	}
	
	function delSubscription($myh_gtu,$myh_src){
		global $eid,$gid;
		$myh_gtu->delNode($gid); //delete
		//decrement count on the source
		$myh_src->decSubscribers($eid);
	}
	
	function delStockSubscription($myh_gtu){
		global $gid;
		$myh_gtu->delNode($gid); //delete
	}
	
	function getPlacement($myh_gtu,$gid){
		$myh_gtu->GTU_SELECT("user");
	
		$nid = $myh_gtu->getNodePID($gid);
		return $myh_gtu->getNodeEID($nid);
	}
	
	function getUserRoot($myh_gtu,$myh_act){
		global $eid;
		$uid = $myh_act->uid;
		$myh_gtu->GTU_SELECT("user");
		$rid = $myh_gtu->c_rid;
		$tid = $this->myh_user_types["cat10"];
		if($myh_act->isAnon){
			//Anon User..
			$tid = $this->myh_user_types["cat20"];
		}
		$pid = $myh_gtu->nodeExists($rid,$tid,$tid);//user or anon
		if($pid){
			$pid = $myh_gtu->nodeExists($pid,$uid,$this->myh_user_types["usr"]); // user id
		}
		return $pid;
	}
	
	function getSubscriptions($myh_gtu,$myh_act,$place=99,$default=0){
		//returns an array of 
		global $eid;
		$uid = $myh_act->uid;
		$subs = array();
		$myh_gtu->GTU_SELECT("user");
		$rid = $myh_gtu->c_rid;
		$tid = $this->myh_user_types["cat10"];
		if($myh_act->isAnon){
			//Anon User..
			$tid = $this->myh_user_types["cat20"];
		}

		if($default){
			$tid = $this->myh_user_types["cat29"];
			$uid = 0;
		}

		$pid = $myh_gtu->nodeExists($rid,$tid,$tid);//user or anon
		if($pid>0){
			$pid = $myh_gtu->nodeExists($pid,$uid,$this->myh_user_types["usr"]); // user id
			if($pid>0){
				$pid = $myh_gtu->nodeExists($pid,$place,$this->myh_user_types["plc"]); //placement
				if($pid>0){
					$nodes = $myh_gtu->listNodes($pid);
					while(list($anid,$apid,$aeid,$atid) = @current($nodes)){
						if($this->MYH_DEBUG){
							echo "getSubscriptions(): ($anid,$apid,$aeid,$atid)<br>\n";
						}
						$subs[]=$aeid;
						next($nodes);
					}
				}
			}
		}
		return $subs;
	}
	
    function isSrcInTree($myh_gtu,$src){
		$myh_gtu->GTU_SELECT("user");
        $nodes = $myh_gtu->findNodes($src,$this->myh_user_types["src"]);
        if(count($nodes)>0)return true;
        return false;
    }
    
   	function delAllSrcEntries($myh_gtu,$sd){
		$myh_gtu->GTU_SELECT("user");
		$rid = $myh_gtu->c_rid;
		$myh_gtu->delAllMatchingNodes($rid,$sd,$this->myh_user_types["src"]);
	}

    function listAllSrcs($myh_gtu){
        $myh_gtu->GTU_SELECT("user");
		return $myh_gtu->listAllOfType($this->myh_user_types["src"]);
    }
	
	/////////////////////////////////////////////////////////////////////
	// Show Tree functions... 
	function showUserSubscriptionsTree($myh_pd,$myh_gtu,$myh_act,$myhLang,$meid=0){
		global $context,$myhPath;
		$output = "";
		if(!($myh_pd->getValue("user_show_1"))){
			//init this view
			if($this->MYH_DEBUG)echo "showUserSubscriptionsTree(): INIT<br>\n";
			$myh_gtu->GTU_SELECT("user","show_1",1,0,1,0);
			$myh_gtu->setGetTextCallBack("myhUserTreeCallBack");
			//defaults
			$myh_gtu->setTypeID($this->myh_user_types["plc"]);
			$myh_gtu->setTypeID($this->myh_user_types["src"]);
			$myh_gtu->setTypeID($this->myh_user_types["stck"]);
			//icons
			$myh_gtu->setIcon($this->myh_user_types["plc"],"<img src=\"$myhPath/images/folder.gif\" border=0>");
			//actions...
			$tempURL = $this->myhURL."&meid=".$meid."&myh=user&myh_op=move_sub";
			$myh_gtu->addAction($this->myh_user_types["src"],$myhLang["Move"],$tempURL);
			$tempURL = $this->myhURL."&meid=".$meid."&myh=user&myh_op=unsub";
			$myh_gtu->addAction($this->myh_user_types["src"],$myhLang["Delete"],$tempURL);
			$tempURL = $this->myhURL."&meid=".$meid."&myh=user&myh_op=del_stock";
			$myh_gtu->addAction($this->myh_user_types["stck"],$myhLang["Delete"],$tempURL);
			//TODO: "Move"
			//turn on flag
			$myh_pd->setValue("user_show_1",1);
		}
		$rid = $this->getUserRoot($myh_gtu,$myh_act);
		$myh_gtu->GTU_SELECT("user","show_1",1,0,1,0);
		if($this->MYH_DEBUG)echo "showUserSubscriptionsTree(): rid = $rid<br>\n";
		if($rid){
			if($this->MYH_DEBUG&&0){
				echo "GTU Vars:<ul>";
				print_vars($myh_gtu);
				echo "</ul>";
			}
			$output = $myh_gtu->drawContextTree($rid,0,$context);
		}else{
			if($this->MYH_DEBUG)echo "showUserSubscriptionsTree(): rid = $rid --> Nothing to see here...<br>\n";
		}
		return $output;		
	}
	
	function showAdminUserSubscriptionsTree($myh_pd,$myh_gtu,$myhLang,$meid=0){
		global $context;
		global $myhPath;
		$output = "";
		if(!($myh_pd->getValue("user_show_adm"))){
			//init this view
			if($this->MYH_DEBUG)echo "showAdminUserSubscriptionsTree(): INIT<br>\n";
			$myh_gtu->GTU_SELECT("user","show_adm");
			$myh_gtu->setGetTextCallBack("myhUserTreeCallBack");
			//defaults
			$myh_gtu->setTypeID($this->myh_user_types["cat10"]);
			$myh_gtu->setTypeID($this->myh_user_types["cat20"]);
			$myh_gtu->setTypeID($this->myh_user_types["cat29"]);
			$myh_gtu->setTypeID($this->myh_user_types["usr"]);
			$myh_gtu->setTypeID($this->myh_user_types["plc"]);
			$myh_gtu->setTypeID($this->myh_user_types["src"]);
			$myh_gtu->setTypeID($this->myh_user_types["stck"]);
			//icons
			$myh_gtu->setIcon($this->myh_user_types["cat10"],"<img src=\"$myhPath/images/folder.gif\" border=0> ");
			$myh_gtu->setIcon($this->myh_user_types["cat20"],"<img src=\"$myhPath/images/folder.gif\" border=0> ");
			$myh_gtu->setIcon($this->myh_user_types["cat29"],"<img src=\"$myhPath/images/folder.gif\" border=0> ");
			$myh_gtu->setIcon($this->myh_user_types["usr"],"<img src=\"$myhPath/images/folder.gif\" border=0> ");
			$myh_gtu->setIcon($this->myh_user_types["plc"],"<img src=\"$myhPath/images/folder.gif\" border=0> ");
			//url
			$tempURL = $this->myhURL."&meid=".$meid."&myh=menu";
			$myh_gtu->setURL($this->myh_user_types["cat10"],$tempURL);
			$myh_gtu->setURL($this->myh_user_types["cat20"],$tempURL);
			$myh_gtu->setURL($this->myh_user_types["cat29"],$tempURL);
			$myh_gtu->setURL($this->myh_user_types["usr"],$tempURL);
			$myh_gtu->setURL($this->myh_user_types["plc"],$tempURL);
			$tempURL = $this->myhURL."&meid=".$meid."&myh=user&myh_op=show_all";
			$myh_gtu->setURL($this->myh_user_types["src"],$tempURL);
			//actions...
			//TODO: Delete, move, etc.
			//turn on flag
			$tempURL = $this->myhURL."&meid=".$meid."&myh=admin&myh_op=ut_del";
			$myh_gtu->addAction($this->myh_user_types["src"],$myhLang["Delete"],$tempURL);
			$tempURL = $this->myhURL."&meid=".$meid."&myh=admin&myh_op=ut_del";
			$myh_gtu->addAction($this->myh_user_types["stck"],$myhLang["Delete"],$tempURL);
			$myh_pd->setValue("user_show_adm",1);
		}
		$myh_gtu->GTU_SELECT("user","show_adm");
		if($this->MYH_DEBUG)echo "showAdminUserSubscriptionsTree(): rid = $rid<br>\n";
		$output = $myh_gtu->drawContextTree(0,0,$context);
	
		return $output;
	}
}
?>